// =============================================================================
//
//  Radio Interface Codes
//
// rewritten from: "FB_Host_Communicate_CSI.h" CoValue

#define COMMUNICATE_HEAD        0xB1
#define COMMUNICATE_END         0xB4

// table of radio to front panel communications 
//  code,  "name"
// acknowledgement code is always = code & 0x8000, high bit set

struct fp_data
{
  int fp_code;   
  char *fp_name; 
}radio_fp_data[56] =
{
{ 0x0001, "HEART_BEAT"},
{ 0x0002, "CPS_READ_WRITE"},
{ 0x0010, "POWERUP_GP_DATA"},
{ 0x0011, "POWERDOWN_NOTIFY"},
{ 0x0013, "POWER_RESTART"},
{ 0x0020, "PTT_KEYTYPE_MSG"},
{ 0x0021, "CHANNEL_SWITCH_MSG"},
{ 0x0022, "VOLUME_CHANGE_MSG"},
{ 0x0023, "PROGRAM_BUTTON_MSG"},
{ 0x0024, "KEYPAD_KEYTYPE_MSG"},
{ 0x0025, "HOOK_CHANGE_MSG"},

{ 0x0040, "DISPLAY_DATA_MSG"},
{ 0x0041, "DISPLAY_CLEAR_ALL"},
{ 0x0042, "DISPLAY_CLR_SECTION"},
{ 0x0043, "DISPLAY_INVERT_CHAR"},
{ 0x0044, "DISPLAY_INVERT_PIC"},
{ 0x0045, "DISPLAY_POSITION_CHAR"},
{ 0x0046, "DISPLAY_POSITION_PIC"},

{ 0x0070, "LED_DISPLAY_MSG"},
{ 0x0071, "LCD_BACKLIGHT_LEV"},
{ 0x0072, "LED_STATUS_QUERY"},
{ 0x0072, "LED_KEYBOARD_CTL"},

//BLUETOOTH  Host->Fb
{ 0x0080, "BT_OP_REQ_PAIRING"},
{ 0x0081, "BT_OP_REQ_CONNECT"},
{ 0x0082, "BT_OP_REQ_DISCONNECT"},
{ 0x0083, "BT_OP_REQ_ACTIVE_AUD"},
{ 0x0084, "BT_OP_REQ_DEACTIVE_AUD"},
{ 0x0085, "BT_OP_REQ_QUERY_STATUS"},
{ 0x0086, "BT_OP_REQ_QUERY_VER"},
{ 0x0087, "BT_OP_REQ_ADJUST_MIC"},
{ 0x0088, "BT_OP_REQ_ADJUST_SPK"},
{ 0x0089, "BT_OP_REQ_OPEN_MODULE"},
{ 0x008A, "BT_OP_REQ_CLOSE_MODULE"},
{ 0x008B, "BT_OP_REQ_UPGRADE"},
{ 0x008C, "BT_OP_REQ_PINCODE"},

//BLUETOOTH  Fb->Host
{ 0x0090, "BT_NOTIFY_SEARCHED"},
{ 0x0091, "BT_NOTIFY_SEARCH_TERMINATED"},
{ 0x0092, "BT_NOTIFY_SEARCH_FINISHED"},
{ 0x0093, "BT_NOTIFY_CONNECTED"},
{ 0x0094, "BT_NOTIFY_DISCONNECTED"},
{ 0x0095, "BT_NOTIFY_BLE_CONNECTED"},
{ 0x0096, "BT_NOTIFY_BLE_DISCONNECTED"},
{ 0x0097, "BT_NOTIFY_NEED_PINCODE"},
{ 0x0098, "BT_NOTIFY_HOST_CONNECT_FAILED"},

// large panel
{ 0x00A0, "LARGE_LCD_PROG_KEYS_FUN"},
{ 0x00A1, "LARGE_LCD_RX_DMR_ACTIVITY"},
{ 0x00A2, "LARGE_LCD_RX_ANALOG_ACTIVITY"},
{ 0x00A3, "LARGE_LCD_SEL_ZONE_CHANNEL"},
{ 0x00A4, "LARGE_LCD_SETP_TEMP_DCH"},
{ 0x00A5, "LARGE_LCD_SETP_TEMP_ACH"},
{ 0x00A6, "LARGE_LCD_STORE_TEMP_CH"},
{ 0x00A7, "LARGE_LCD_CHANGE_SQL_LEVEL"},
{ 0x00A8, "LARGE_LCD_ENTRY_QUICK_MENU"}
}
