//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// Mar 23, 2018             Design Documents                            clocks.h
//
//			header for Large display frequencies
//
// Programmer
//  Dean S. Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//  03/23/2018
//
// Status
//  writing
//
//==============================================================================
#ifndef CLOCKS_H_
#define CLOCKS_H_

// HSI high speed internal clock  16 Mhz,  CPU clock at startup

// #define CLCK_HSE	  8000000   // external oscillator frequency 8 Mhz crystal
#define CLCK_HSE	 12000000   // external oscillator frequency 12 Mhz crystal
#define CLCK_AHB	168000000   // main ARM clock GPIO, ETHERNET, DMA
#define CLCK_APB2	 84000000   // APB2 High speed AHB/2 USART1, timers, SPI
#define CLCK_APB1	 42000000   // APB1 Low speed AHB/4 USART2, SPI, I2C
#define CLCK_SYSTCK      21000000   // systick AHB/8

#define CLCK_LSI	    32000   // low speed internal, watchdog

#define CLCK_UART1	   57600  // 57.6 baud CS800D
#define CLCK_UART2	   62500  // 62.5 baud FT857
#define CLCK_I2C	  100000  // 100 Khz

// There is a prescaler in the timer modules that multiplies the clock x 2.
// Ref Manual pg 153.
// The register that has the setting for the multiplier is not listed in the 
// Debugger registers for the CPU.  
// RCC_DCKCFGR pg. 207 bit 24 


#endif /* CLOCKS_H_ */
