//
//  STM32F4 Core Registers
//   Revised from original for STM32F7
//   
//  STATUS: Needs checking
// 
//==============================================================================
//
//  System Control Block Registers
//
#define ACTLR_ADDRESS       0xE000E008  // Auxilliary Control register
#define ACTLR_ADDRESS       0xE000E008  // CPUID Base register
#define ICSR_ADDRESS        0xE000ED04  // Interrupt Control and State register
#define VTOR_ADDRESS        0xE000ED08  // Vector Table Offset register
#define AIRCR_ADDRESS       0xE000ED0C  // Application Interrupt and Reset register
#define SCR_ADDRESS         0xE000ED10  // System Control register
#define CCR_ADDRESS         0xE000ED14  // Configuration and Control register
#define SHPR1_ADDRESS       0xE000ED18  // System Handler and Priority register 1
#define SHPR2_ADDRESS       0xE000ED1C  // System Handler and Priority register 2
#define SHPR3_ADDRESS       0xE000ED20  // System Handler and Priority register 3
#define SHCSR_ADDRESS       0xE000ED24  // System Handler Control and State register
#define CFSR_ADDRESS        0xE000ED28  // Configurable Fault Status register
// CFSR sub registers MMSR, BFSR, UFSR are within CFSR 32 bits 
#define HFSR_ADDRESS        0xE000ED2C  // Hard Fault Status register
#define MMAR_ADDRESS        0xE000ED34  // MemManage Faust Address register
#define BFAR_ADDRESS        0xE000ED38  // BusFault Address register
#define CPACR_ADDRESS       0xE000ED88  // Coprocessor Access Control Register
//
// SysTick System Timer
//
#define STK_CTRL_ADDRESS          0xE000E010   // SysTick Control and Status Register
#define STK_LOAD_ADDRESS          0xE000E014   // SysTick Reload Value Register
#define STK_VAL_ADDRESS           0xE000E018   // SysTick Current Value Register
#define STK_CALIB_ADDRESS         0xE000E01C   // SysTick Calibration Value Register
//
// Nested Vectored Interrupt Controller
//
#define NVIC_ISER0_ADDRESS  0xE000E100  // Interrupt 0 Set-enable register
#define NVIC_ISER1_ADDRESS  0xE000E104  // Interrupt 1 Set-enable register
#define NVIC_ISER2_ADDRESS  0xE000E108  // Interrupt 2 Set-enable register
#define NVIC_ISER3_ADDRESS  0xE000E10C  // Interrupt 3 Set-enable register
#define NVIC_ISER4_ADDRESS  0xE000E110  // Interrupt 4 Set-enable register
#define NVIC_ISER5_ADDRESS  0xE000E114  // Interrupt 5 Set-enable register
#define NVIC_ISER6_ADDRESS  0xE000E118  // Interrupt 6 Set-enable register
#define NVIC_ISER7_ADDRESS  0xE000E11C  // Interrupt 7 Set-enable register

#define NVIC_ICER0_ADDRESS  0xE000E180  // Interrupt 0 Clear-enable register
#define NVIC_ICER1_ADDRESS  0xE000E184  // Interrupt 1 Clear-enable register
#define NVIC_ICER2_ADDRESS  0xE000E188  // Interrupt 2 Clear-enable register
#define NVIC_ICER3_ADDRESS  0xE000E18C  // Interrupt 3 Clear-enable register
#define NVIC_ICER4_ADDRESS  0xE000E190  // Interrupt 4 Clear-enable register
#define NVIC_ICER5_ADDRESS  0xE000E194  // Interrupt 5 Clear-enable register
#define NVIC_ICER6_ADDRESS  0xE000E198  // Interrupt 6 Clear-enable register
#define NVIC_ICER7_ADDRESS  0xE000E19C  // Interrupt 7 Clear-enable register

#define NVIC_ISPR0_ADDRESS  0xE000E200  // Interrupt 0 set-pending register
#define NVIC_ISPR1_ADDRESS  0xE000E204  // Interrupt 1 set-pending register
#define NVIC_ISPR2_ADDRESS  0xE000E208  // Interrupt 2 set-pending register
#define NVIC_ISPR3_ADDRESS  0xE000E20C  // Interrupt 3 set-pending register
#define NVIC_ISPR4_ADDRESS  0xE000E210  // Interrupt 4 set-pending register
#define NVIC_ISPR5_ADDRESS  0xE000E214  // Interrupt 5 set-pending register
#define NVIC_ISPR6_ADDRESS  0xE000E218  // Interrupt 6 set-pending register
#define NVIC_ISPR7_ADDRESS  0xE000E21C  // Interrupt 7 set-pending register

#define NVIC_ICPR0_ADDRESS  0xE000E280  // Interrupt 0 clear-pending register
#define NVIC_ICPR1_ADDRESS  0xE000E284  // Interrupt 1 clear-pending register
#define NVIC_ICPR2_ADDRESS  0xE000E288  // Interrupt 2 clear-pending register
#define NVIC_ICPR3_ADDRESS  0xE000E28C  // Interrupt 3 clear-pending register
#define NVIC_ICPR4_ADDRESS  0xE000E290  // Interrupt 4 clear-pending register
#define NVIC_ICPR5_ADDRESS  0xE000E294  // Interrupt 5 clear-pending register
#define NVIC_ICPR6_ADDRESS  0xE000E298  // Interrupt 6 clear-pending register
#define NVIC_ICPR7_ADDRESS  0xE000E29C  // Interrupt 7 clear-pending register

#define NVIC_IABR0_ADDRESS  0xE000E300  // Interrupt 0 Interrupt Active Bit register
#define NVIC_IABR1_ADDRESS  0xE000E304  // Interrupt 1 Interrupt Active Bit register
#define NVIC_IABR2_ADDRESS  0xE000E308  // Interrupt 2 Interrupt Active Bit register
#define NVIC_IABR3_ADDRESS  0xE000E30C  // Interrupt 3 Interrupt Active Bit register
#define NVIC_IABR4_ADDRESS  0xE000E310  // Interrupt 4 Interrupt Active Bit register
#define NVIC_IABR5_ADDRESS  0xE000E314  // Interrupt 5 Interrupt Active Bit register
#define NVIC_IABR6_ADDRESS  0xE000E318  // Interrupt 6 Interrupt Active Bit register
#define NVIC_IABR7_ADDRESS  0xE000E31C  // Interrupt 7 Interrupt Active Bit register

// NVIC_IPR0 - NVIC_IPR59  calculate from first register
#define NVIC_IPR0_ADDRESS   0xE000E400  // Interrupt Priority Registers

