//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// November 4, 2019          Design Documents                  CSI_TGM_Monitor.h
//
//	            header file for Talk Group Monitor
//                     Large panel display project
//
// Programmer
//  Dean S. Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//  11/04/2019 started
//
// Status
//  writing
//
//******************************************************************************
#ifndef CSI_TGM_MONITOR_H_
#define CSI_TGM_MONITOR_H_

extern volatile uint32_t TGM_call_seconds;  // current call seconds counter
extern char TGM_group_id[ 17 ];    // current call group name string

extern uint8_t TGM_monitor_on;   // flag set when montior feature is runnig
extern uint8_t TGM_call_active;  // flag set while receiving a call 
extern uint8_t TGM_update;

// functions
void TGM_clear_table( void );
void TGM_new_call( void );
void TGM_end_call( void );
void TGM_sort( void );
void TGM_display_graph( void );
void TGM_display_text( uint8_t page_num );
void process_EMon_mode( uint8_t nav_key );
 

typedef struct
{
  uint32_t  record_ID;     // unique record ID number
  char      talkgroup[17]; // from uint8_t  cs_rx_group_id_alias[17]
  uint32_t  seconds;       // number of seconds 
  uint32_t  contacts;      // number of contacts
} TGM_record;

#endif /* CSI_TGM_MONITOR_H_ */