//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// Jan, 3 2017             Design Documents                          error_log.h
//
//			header for error log and event log
//             mostly for debugging
//
// Programmer
//  Dean S. Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//  01/03/2017 started
//  03/20/2018 added to Large Display project
//
// Status
//  writing
//
//==============================================================================

#ifndef ERROR_LOG_H_
#define ERROR_LOG_H_

extern unsigned int current_error;
extern unsigned int error_count;

extern int error_record[100];
extern unsigned int event_log_indx;

char* get_event( int index );

// function prototypes
int error_log( int error_number);
void error_log_flush( void );
void log_event( char* ev_text );
void display_error( int );

void log_packet( char* id_text );

char* get_error_text( int error_num );

#endif /* ERROR_LOG_H_ */
