//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// May, 10 2019             Design Documents                        CSI_FT857D.h
//
//	       	   	    header for FT857D
//                      for Large Panel Project
//
// Programmer
//  Jerry Wanger, Dean Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//  05/09/2019 DSG, moved header information here from .c file
//
// Status
//  written
//
//==============================================================================
#ifndef FT857D_H_
#define FT857D_H_

// buffers
extern uint8_t FT857D_tx_buffer[];
extern uint8_t FT857D_rx_buffer[];

// variables
extern uint8_t FT857_sq_type;
extern uint8_t FT857_squelch_value;
extern uint8_t FT857_volume_value;
extern uint8_t FT857D_rfsql_mode;

extern uint8_t FT857_savd_sq_type;
extern uint8_t FT857_savd_squelch_value;
extern uint8_t FT857_savd_volume_value;

extern uint32_t special_encoder_flag;
extern uint8_t FT857D_radio_active;
extern uint32_t FT857D_cursor_timer;
extern uint32_t RKnob_delay_timer;
extern uint32_t LKnob_delay_timer;

// colors for radio screen
extern uint8_t  FT857D_red;
extern uint8_t  FT857D_green;
extern uint8_t  FT857D_blue;
extern uint8_t  FT857D_background_red;
extern uint8_t  FT857D_background_green;
extern uint8_t  FT857D_background_blue;


// functions
void initialize_FT857_startup(void);
void process_FT857D_packets(void);
void process_blinking_cursor(void);
void save_FT857_info( uint8_t sq_type, uint8_t sq_knob, uint8_t vol_knob );
void load_FT857_info( void );
void clear_radio_screen_and_rewrite_lines( void );
void FT857_display_squelch_graph( void );
void FT857_clear_squelch_graph( void );

void FT857D_clear_mirror_line( uint8_t line_num);

void process_release_packet(void);
void FT857D_mechanical_switches(void);
void FT857D_set_squelch( uint8_t squelch );
void FT857D_set_volume( uint8_t volume );
void FT857D_set_knobs( void );

#endif /* FT857D_H_ */