//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// January 23, 2019  		Design Documents             CSI_FT857_screens.h 
// 
//       Header for Graphics routines for LCD display
//           for FT857 large display project
//
// Programmer
//  Dean S. Graham
// 
// Copyright 
//  Connect Systems Inc.
//
// History
//  01/23/2019  started
//
// Status
//  writing
//
//==============================================================================
#ifndef CSI_FT857_SCREENS_H_
#define CSI_FT857_SCREENS_H_

#include <stdint.h>

// variables
extern int FT857_active_screen_num;
// typedefs

// screen message
// active, x, y upper left corner, font
typedef struct 
  {
  uint8_t active;  
  uint16_t x_pos;
  uint16_t y_pos;
  uint8_t font; 
  }message_info;

extern message_info FT857_Message[5];

// screen buttons
// is_active, x , y, text, font, icon 
typedef struct 
  {
  uint8_t active;
  uint16_t x_pos;
  uint16_t y_pos;    
  char *text;
  uint8_t font;
  unsigned char *icon;
  }button_info;

// functions
void FT857_display_screen( uint8_t screen_num, uint8_t clear );
void FT857_draw_button( uint8_t B_num, uint8_t bordr_color, uint8_t face_color );
void FT857_display_volume_bar(uint8_t volume_value);
void FT857_erase_volume_bar(void);
void FT857_display_squelch_bar(uint8_t squelch_value);
void FT857_erase_squelch_bar(void);
void FT857_display_message( uint8_t line_num, char* text );
void FT857_clear_radio_screen( void );
void FT857_clear_message( uint8_t line_num );

void display_rxdata_dump( uint8_t * rx_buffer );


#endif /* CSI_SCREENS_H_ */