//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// March 11, 2019             Design Documents                    CSI_GPIO.h
//
//			header file for GPIO
//                     Large panel display project
//
// Programmer
//  Dean S. Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//  03/11/2019  moved declarations from Functions.h
//
// Status
//  writing
//
// ******************************************************************************
#ifndef GPIO_H_
#define GPIO_H_
#include <stdint.h>

extern uint32_t volatile *GPIO_A_MODER;
extern uint32_t volatile *GPIO_A_ALTHI;
extern uint32_t volatile *GPIO_A_IDR;
extern uint32_t volatile *GPIO_A_BSRR;

extern uint32_t volatile *GPIO_B_MODER; 
extern uint32_t volatile *GPIO_B_ALTLO;
extern uint32_t volatile *GPIO_B_IDR;
extern uint32_t volatile *GPIO_B_BSRR; 

extern uint32_t volatile *GPIO_C_MODER; 
extern uint32_t volatile *GPIO_C_ALTLO;
extern uint32_t volatile *GPIO_C_IDR;
extern uint32_t volatile *GPIO_C_BSRR; 

extern uint32_t volatile *GPIO_D_MODER; 
extern uint32_t volatile *GPIO_D_ALTLO;
extern uint32_t volatile *GPIO_D_IDR;
extern uint32_t volatile *GPIO_D_BSRR; 

extern uint32_t volatile *GPIO_E_MODER; 
extern uint32_t volatile *GPIO_E_ALTLO;
extern uint32_t volatile *GPIO_E_IDR;
extern uint32_t volatile *GPIO_E_BSRR; 

extern uint32_t volatile *GPIO_F_MODER; 
extern uint32_t volatile *GPIO_F_ALTLO;
extern uint32_t volatile *GPIO_F_IDR;
extern uint32_t volatile *GPIO_F_BSRR; 

extern uint32_t volatile *GPIO_G_MODER; 
extern uint32_t volatile *GPIO_G_ALTLO;
extern uint32_t volatile *GPIO_G_IDR;
extern uint32_t volatile *GPIO_G_BSRR; 
extern uint16_t volatile *GPIO_G_ODR;

// GPIO Functions
uint8_t read_switch_s1(void);
uint8_t read_switch_s2(void);
uint8_t read_switch_s3(void);
uint8_t read_switch_s4(void);
uint8_t read_switch_s5(void);
uint8_t read_switch_s6(void);
uint8_t read_rotary_encoder_1_0(void);
uint8_t read_rotary_encoder_1_1(void);
uint8_t read_rotary_encoder_2_0(void);
uint8_t read_rotary_encoder_2_1(void);
uint32_t read_ptt(void);
void rx_led_on(void);
void rx_led_off(void);
void tx_led_on(void);
void tx_led_off(void);
void key_backlight_on(void);
void key_backlight_off(void);
void lcd_backlight_on(void);
void lcd_backlight_off(void);
void lcd_cs_high(void);
void lcd_cs_low(void);
void lcd_d_c_high(void);
void lcd_d_c_low(void);
void lcd_rd_high(void);
void lcd_rd_low(void);
void lcd_wr_high(void);
void lcd_wr_low(void);
void lcd_reset_high(void);
void lcd_reset_low(void);
uint32_t read_lcd_tear(void);
uint8_t read_lcd_port(void);
void write_lcd_port(uint8_t lcd_data);
uint32_t read_mike_hook(void);
uint32_t read_mike_ptt(void);
uint32_t read_mike_dm(void);
uint32_t read_mike_mbl(void);
void mike_dm_high(void);
void mike_dm_low(void);
void mike_mbl_high(void);
void mike_mbl_low(void);

#endif /* UART_H_ */
