//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// April 26, 2018		Design Documents                  CSI_graphics.h 
// 
//       Header for Graphics routines for LCD display
//           for large display project
//
// Programmer
//  Dean S. Graham
// 
// Copyright 
//  Connect Systems Inc.
//
// History
//  04/26/2018  started
//
// Status
//  writing
//
//==============================================================================
#ifndef CSI_GRAPHICS_H_
#define CSI_GRAPHICS_H_
#include "CSI_COLOR.h"

void WR_cycle( void );
void draw_pixel(uint16_t Xpos, uint16_t Ypos, RGB_color colr);
void draw_rectangle( uint16_t startX, uint16_t startY, uint16_t width,
                            uint16_t height, RGB_color colr);
void clear_rectangle( uint16_t startX, uint16_t startY,
                     uint16_t width, uint16_t height);
void color_rectangle(uint16_t startX, uint16_t startY,
                     uint16_t width, uint16_t height);
void draw_line( int ltype, uint16_t startX, uint16_t startY, uint16_t length,
                     uint16_t width, RGB_color colr);
void draw_frame( uint16_t startX, uint16_t startY, uint16_t length,
               uint16_t height, uint16_t border_size, RGB_color colr);
void draw_shaded_frame( uint16_t startX, uint16_t startY, uint16_t length,
                     uint16_t height, uint16_t border_size,
                     RGB_color c_colr, RGB_color s_colr);
void draw_icon( uint8_t *icondata, uint16_t startX, uint16_t startY,
               uint8_t foreg_color, uint8_t backgr_color);
void draw_icon_bkg( uint8_t *icondata, uint16_t startX, uint16_t startY );

void draw_progress_bar( uint8_t percent_fill, int bar_type,
                    uint16_t startX, uint16_t startY,
                    uint16_t width, uint16_t height,
                    uint8_t frame_color, uint8_t bar_color, uint8_t backg_color);
void draw_icon_rle( uint8_t *icondata, uint16_t startX, uint16_t startY );
void draw_icon_mirrored( uint8_t *icondata, uint16_t startX, uint16_t startY, uint8_t usebkg );

void display_cursor( uint8_t onoff, uint16_t pos_x, uint16_t pos_y, uint8_t font );
void cursor_blink( uint16_t pos_x, uint16_t pos_y, uint8_t font );
void draw_dial_spin( uint16_t pos_x, uint16_t pos_y,  uint8_t rotation );


#endif /* CSI_GRAPHICS_H_ */

