//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// June 3, 2019             Design Documents                          CSI_MC59.h
//
//	       header file for MC59 keypad microphone
//                    Large panel display project
//
// Programmer
//  Dean S. Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//
// Status
//  written
//
//******************************************************************************
#ifndef CSI_MC59_H_
#define CSI_MC59_H_

// MC59 Functions
//
void mc59_read_keypad(void);
void process_keypad(void);
void mc59_get_data(void);

// MC59 Variables
extern uint32_t mc59_raw_data;
extern uint32_t mc59_flag;
extern uint32_t mc59_key;
extern uint32_t mc59_release_flag;
extern uint32_t mc59_temp_raw_data;

extern uint8_t ascii_convert_string[17];

extern uint32_t process_keypad_state;
extern uint32_t parm_char;
extern uint32_t parm_char_flag;
extern uint32_t radio_keypad_char;
extern uint32_t radio_keypad_flag;
extern uint32_t radio_keypad_release_char;
extern uint32_t radio_keypad_release_flag;

extern uint32_t dtmf_code_flag;
extern uint32_t dtmf_char;
extern uint32_t dtmf_code_char;
extern uint32_t dtmf_codes_timer;

#endif /* CSI_MC59_H_ */
