//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// September 5, 2018          Design Documents                   process_FT857.h
//
//			header for process packets
//                    UART1 communication with FT857
//                      for Large Panel Project
//
// Programmer
//  Dean S. Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//  09/05/2018 copied from process_packets (CS800D) for revision to FT987
//
// Status
//  writing
//
//==============================================================================
#ifndef PROCESS_FT857_H_
#define PROCESS_FT857_H_

#include <stdint.h>
#include "CSI_SCREENS.h"

extern char packet_test[6];
extern char radio_start[6];

extern uint32_t radio_watchdog_timer;;

extern uint8_t  cs_channel_alias[16];
extern uint32_t cs_channel_alias_length;
extern uint8_t  cs_channel_zone_alias[16];
extern uint32_t cs_channel_zone_alias_length; 
extern uint32_t cs_channel_rx_frequency;
extern uint32_t cs_channel_tx_frequency;
extern uint32_t cs_channel_number_in_zone;
extern uint32_t cs_channel_zone_number;
extern uint32_t cs_channel_number; 
extern uint32_t cs_channel_rssi;
extern uint32_t cs_channel_battery_level;
extern uint32_t cs_channel_scan;
extern uint32_t cs_channel_power_level;
extern uint32_t cs_channel_privacy;
extern uint32_t cs_channel_message;
extern uint32_t cs_channel_gps;
extern uint32_t cs_channel_disable_tone;
extern uint32_t cs_channel_talk_around;
extern uint32_t cs_channel_monitor;
extern uint32_t cs_channel_type;
extern uint32_t cs_channel_mode;
extern uint32_t cs_channel_emergency;
extern uint32_t cs_channel_bt_state;
extern uint32_t cs_channel_link;
extern uint32_t cs_channel_volume;

extern uint32_t cs_channel_active;
extern uint32_t cs_channel_new;

// for menu
extern uint8_t cs_menu_page;
extern uint16_t debug_p_line;

extern uint8_t list_active;
extern uint8_t info_box_active;

// for lastcall popup
extern uint8_t last_call_recs;
extern uint8_t last_call_indx;
extern Last_call_info Last_call_table[10];

extern uint8_t pckt_msg1_dirty;
extern uint8_t pckt_msg2_dirty;
extern uint8_t pckt_msg3_dirty;
extern uint8_t pckt_msg4_dirty;

// Function prototypes

void process_FT857(void);
uint32_t packet_type_0(void);
/*
uint32_t packet_type_1(void);
uint32_t packet_type_2(void);
uint32_t packet_type_3(void);
uint32_t packet_type_4(void);
uint32_t packet_type_5(void);
uint32_t packet_type_6(void);
uint32_t packet_type_7(void);
uint32_t packet_type_8(void);
uint32_t packet_type_9(void);
uint32_t packet_type_10(void);
uint32_t packet_type_11(void);
uint32_t packet_type_12(void);
uint32_t packet_type_13(void);
uint32_t packet_type_14(void);
uint32_t packet_type_15(void);

void packet_buffer_transfer(void);
void process_all_packet(void);
void packet_buffer_0_output(void);
void packet_buffer_1_output(void);
void packet_buffer_2_output(void);
void packet_buffer_3_output(void);
void packet_buffer_4_output(void);
void packet_buffer_5_output(void);
void packet_buffer_6_output(void);
void packet_buffer_7_output(void);
void packet_buffer_8_output(void);
void packet_buffer_9_output(void);
void packet_buffer_10_output(void);
void packet_buffer_11_output(void);
void packet_buffer_12_output(void);
void packet_buffer_13_output(void);
void packet_buffer_14_output(void);
void packet_buffer_15_output(void);

void packet_buffer_3_display(void);
void packet_buffer_4_display(void);
void packet_buffer_5_display(void);
void packet_buffer_6_display(void);
void packet_buffer_7_display(void);
void packet_buffer_8_display(void);
void packet_buffer_9_display(void);
void packet_buffer_10_display(void);
void packet_buffer_11_display(void);
void packet_buffer_12_display(void);
void packet_buffer_13_display(void);
void packet_buffer_14_display(void);
void packet_buffer_15_display(void);

uint32_t extract_message(uint32_t);
void display_volume_bar(uint8_t);
void output_icons_to_display(void);
// void calculate_line_center(void);
uint16_t calculate_line_center(uint8_t font, uint8_t spacing, uint8_t numbytes);
void  output_special_icons(void);

// packet data display functions
void  display_pkt1_volume(void);

void clear_pckt_message( uint8_t messnum );
void display_packet_dump( void );

void display_pkt1_4_msg1(void);
void display_pkt1_4_msg2(void);

void display_channel_alias(void);
void display_channel_rx_frequency(void);
void display_channel_tx_frequency(void);
void display_zone_alias(void); 
void display_channel_number_in_zone(void);
void display_zone_number(void);
void display_channel_number(void);
void display_channel_rssi(void);
void display_channel_battery(void);
void display_channel_scan(void);
void display_channel_power(void);
void display_channel_privacy(void);
void display_channel_message(void); 
void display_channel_gps(void); 
void display_channel_disable_tone(void);
void display_channel_talk_around(void);
void display_channel_monitor(void);
void display_channel_type(void);
void display_channel_mode(void);
void display_channel_emergency(void);
void display_channel_bt_state(void);
void display_channel_link(void);
void display_channel_volume(void);

void display_pkt1_6_msg1(void);

void display_pkt1_7_msg1(void);
void display_pkt1_7_msg2(void);

void display_pkt1_8_msg1(void);
void display_pkt1_8_msg2(void);

void display_pkt1_9_msg1(void);
void display_pkt1_9_msg2(void);

void display_pkt1_10_msg1(void);
void display_pkt1_10_msg2(void);

void display_pkt1_11_msg1(void);
void display_pkt1_11_msg2(void);

void display_pkt1_12_msg1(void);
void display_pkt1_12_msg2(void);

void display_pkt1_13_icon(void);
void display_pkt1_13_msg1(void);
void display_pkt1_13_msg2(void);

void display_pkt1_14_msg1(void);
void display_pkt1_14_msg2(void);

void display_pkt1_15_msg1(void);
void display_pkt1_15_msg2(void);

void set_channel_bits(uint32_t, uint32_t, uint32_t);
void set_pkt1_bits(uint32_t, uint32_t, uint32_t);
void set_pkt2_bits(uint32_t, uint32_t, uint32_t);
void display_debug_p( void );
*/

#endif /* PROCESS_FT857_H_ */
