//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// June 3, 2019             Design Documents                   CSI_PROGRAMMING.h
//
//	          header file for CS800D radio programming
//                    Large panel display project
//
// Programmer
//  Dean S. Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//
// Status
//  written
//
//******************************************************************************
#ifndef CSI_PROGRAMMING_H_
#define CSI_PROGRAMMING_H_

//
// PROCESS_CODES Functions
//
void factory_reset_code(void);
void programming_code(void);
void process_codes(void);
//
// PROGRAMMING Functions
//
void parameter_program(void);                          
void ParameterStates(void);
//
// PROGRAMMING Functions: Enter Parameter number
//
void param_state0(void);
void param_state1(void);
void param_state2(void);
void param_state3(void);
void param_state4(void);
void param_state5(void);
//
// PROGRAMMING Functions: Numeric Parameters
//
void param_state10(void);
void param_state11(void);
void param_state12(void);
void param_state13(void);
void param_state14(void);
//
// PROGRAMMING Functions: Alphanumeric Parameters
//
void param_state20(void);
void param_state21(void);
void param_state22(void);
void param_state23(void);
void param_state24(void);
//
// PROGRAMMING Functions: Support Functions
//
void initialize_parameters(void);
void display_line_0(uint8_t);
void display_line_e(uint8_t);
void array_to_buffer(uint8_t);
void clear_parm_buffer(void);
void load_fcb_from_array(uint32_t);
void set_cursor(void);
void remove_cursor(void);
void move_cursor_right(void);
void move_cursor_left(void); 
void write_char_at_cursor(uint8_t);
void clear_parm_number_display(void);
void display_fatal_error(uint8_t);
void call_functions(uint16_t);

//
// PROCESS_CODES Variables
//
extern uint32_t dtmf_codes_timer;
extern uint32_t factory_reset_state;
extern uint32_t programming_code_state;
extern uint32_t dtmf_codes_timer;
extern uint32_t factory_initialize_flag;
extern uint32_t ProgramFlag;
//
//Programming Variables
//
extern uint32_t WatchDogTimer;
extern uint32_t ParameterState;
extern uint32_t numeric_flag;
extern uint32_t pound_counter;
extern uint32_t ProgramFlag;
extern uint32_t parm_char_flag;
extern uint32_t first_auto_advance_flag;
extern uint32_t special_characters;
extern uint32_t parm_buffer_pointer;
extern uint32_t parameter_number;
extern uint32_t parm_buffer[];
extern uint16_t load_fcb_buffer[];

extern uint16_t opcode;
extern uint16_t display_line_1;
extern uint16_t display_line_2;
extern uint16_t data_entry;
extern uint16_t display_old;
extern uint16_t function_begin;
extern uint16_t function_end;
extern uint16_t store_data;
extern uint16_t auto_advance;
extern uint16_t first_auto_advance;

#endif /* CSI_PROGRAMMING_H_ */