//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// June 3, 2019             Design Documents                        CSI_TIMERS.h
//
//	            header file for timer routines
//                    Large panel display project
//
// Programmer
//  Dean S. Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//     moved here from CSI_FUNCTIONS.h
//
// Status
//  written
//
//******************************************************************************
#ifndef CSI_TIMERS_H_
#define CSI_TIMERS_H_

#include <stdint.h>
//
// TIMER Functions
//
void SysTick_Handler( void );
void timer_100us(void);
void timer_10ms(void);
void timer_100ms(void);
void delay(uint32_t);
void wait_12_nanoseconds(void);
void wait_36_nanoseconds(void);
void wait_100_nanoseconds(void);
void msec_delay( unsigned int );

extern uint32_t timer_error;
extern uint32_t acknowledgement_delay;

// Timer variables
extern unsigned long volatile millisec;
extern uint32_t ms_1_timer;
extern uint32_t ms_10_timer;
extern uint32_t pre_100us_timer;
extern uint32_t pre_10ms_timer;
extern uint32_t FT857D_uart_rx_watch_dog_timer;
extern uint32_t WatchDogTimer;
extern uint32_t FT857D_startup_timer;
extern uint32_t FT857D_auto_init_timer;

#endif /* CSI_TIMERS_H_ */
