//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// Jun 19, 2018             Design Documents                   CSI_diagnostics.h
//
//			header for Large display diagnostics
//
// Programmer
//  Dean S. Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//  06/19/2018
//
// Status
//  writing
//
//==============================================================================
#ifndef DIAGS_H_
#define DIAGS_H_

#include <stdint.h>

void msec_delay( unsigned int delay );

void diagnostic( int dnumber );
void test_pin( void );
void blink_red ( unsigned int blinks );
void blink_green ( unsigned int blinks );
void blink_alternate( void );
void keypad_backlight ( unsigned int msec );  // not used in proto 2 
void screen_backlight ( unsigned int timesec );
void cpu_clocks( void );
void systick_check( int msec );
void keypad_check( void );
uint8_t Rotary_enc_test( uint8_t rencoder );
void LCD_pins_test( unsigned int testime ) ;
uint8_t LCD_controller_check( void );
void UART1_transmit_test( void );
void clock_nop_test( void );
void LCD_color_test( void );
void LCD_font_test( uint8_t font_num );
void LCD_rssiIcon_test( void );
void LCD_batteryIcon_test( void );

// old dbugging tests
void I2C_EEPROM_test ( void );
void I2C_EEPROM_test2( void );
uint32_t SPI_FLASH_test( void );

// board test routines 
void process_board_tests( void );
int Board_I2C_EEPROM( void );
int Board_Flash_mfrid( void );
int Board_Flash_uniqueid( void );
int Board_Flash_RW( void );
void clear_message_area( void );
int Board_switches( uint8_t switch_num );
int Board_Lknob_switch( void );
int Board_Rknob_switch( void );
int Board_Lknob_rotate( void );
int Board_Rknob_rotate( void );
int Board_PTT( void );
int Board_MICkeypad( void );
int Board_Touchscreen( void );
int Board_Volume( void );
int Board_Channel( void );
int Board_UART1( void );
int Board_UART2( void );
int Board_USB1( void );
int Board_USB2( void );

#endif /* DIAGS_H_ */
