//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
///
// Mar 23, 2018			Design Documents                 CSI_interrupt.h 
// 
//      header for interrupt routines
//
// Programmer
//  Dean Graham
// 
// Copyright 
//  Connect Systems Inc.
//
// History
//  03/23/2018 started
//==============================================================================
#ifndef CSI_interrupt_H_
#define CSI_interrupt_H_

#include <stdint.h>

// interrupt number list for STM32F405
// most are not being used

//#define  NMI_INTR             -11
//#define  HardFault_INTR       -10
//#define  MemManage_INTR       -9
//#define  BusFault_INTR        -8
//#define  UsageFault_INTR      -7
// #define  0, reserved         -6
//#define  SVC_INTR             -5
//#define  DebugMon_INTR        -4
// #define  0, reserved         -3
//#define  PendSV_INTR          -2
#define  SysTick_INTR         -1
//0 
//#define WWDG_INTR               0
//#define PVD_INTR                1
//#define TAMP_STAMP_INTR         2
//#define RTC_WKUP_INTR           3
//#define FLASH_INTR              4
//#define RCC_INTR                5
//#define EXTI0_INTR              6
//#define EXTI1_INTR              7
#define EXTI2_INTR              8
//#define EXTI3_INTR              9
//#define EXTI4_INTR              10
//#define DMA1_STREAM0_INTR       11
//#define DMA1_STREAM1_INTR       12
//#define DMA1_STREAM2_INTR       13
//#define DMA1_STREAM3_INTR       14
//#define DMA1_STREAM4_INTR       15
//#define DMA1_STREAM5_INTR       16
//#define DMA1_STREAM6_INTR       17
//#define ADC_INTR                18
//#define CAN1_TX_INTR            19
//#define CAN1_RX0_INTR           20
//#define CAN1_RX1_INTR           21
//#define CAN1_SCE_INTR           22
#define EXTI9_5_INTR            23
//#define TIM1_BRK_TIM9_INTR      24
//#define TIM1_UP_TIM10_INTR      25
//#define TIM1_TRG_COM_TIM11_INTR 26
//#define TIM1_CC_INTR            27
#define TIM2_INTR               28
//#define TIM3_INTR               29
//#define TIM4_INTR               30
//#define I2C1_EV_INTR            31
//#define I2C1_ER_INTR            32
#define I2C2_EV_INTR            33
#define I2C2_ER_INTR            34
#define SPI1_INTR               35
//#define SPI2_INTR               36
#define USART1_INTR             37
#define USART2_INTR             38
//#define USART3_INTR             39
//#define EXTI15_10_INTR          40
//#define RTC_Alarm_INTR          41
//#define OTG_FS_WKUP_INTR        42
//#define TIM8_BRK_TIM12_INTR     43
//#define TIM8_UP_TIM13_INTR      44
//#define TIM8_TRG_COM_TIM14_INTR 45
//#define TIM8_CC_INTR            46
//#define DMA1_Stream7_INTR       47
//#define FSMC_INTR               48
//#define SDIO_INTR               49
//#define TIM5_INTR               50
//#define SPI3_INTR               51
//#define UART4_INTR              52
//#define UART5_INTR              53
//#define TIM6_DAC_INTR           54
//#define TIM7_INTR               55
//#define DMA2_Stream0_INTR       56
//#define DMA2_Stream1_INTR       57
//#define DMA2_Stream2_INTR       58
//#define DMA2_Stream3_INTR       59
//#define DMA2_Stream4_INTR       60
//#define ETH_INTR                61
//#define ETH_WKUP_INTR           62
//#define CAN2_TX_INTR            63
//#define CAN2_RX0_INTR           64
//#define CAN2_RX1_INTR           65
//#define CAN2_SCE_INTR           66
//#define OTG_FS_INTR             67
//#define DMA2_Stream5_INTR       68
//#define DMA2_Stream6_INTR       69
//#define DMA2_Stream7_INTR       70
//#define USART6_INTR             71
//#define I2C3_EV_INTR            72
//#define I2C3_ER_INTR            73
#define OTG_HS_EP1_OUT_INTR     74
#define OTG_HS_EP1_IN_INTR      75
#define OTG_HS_WKUP_INTR        76
#define OTG_HS_INTR             77
//#define DCMI_INTR               78
//#define CRYP_INTR               79
//#define HASH_RNG_INTR           80
//#define FPU_INTR                81

// function prototypes
inline void enable_interrupts(void);
inline void disable_interrupts(void);
void nvic_enableIRQ( uint8_t );
void nvic_disableIRQ( uint8_t );
void SWI_config( uint8_t );
void SWE_config( uint8_t );
void SWIE_activate ( uint8_t );
void trigger_enable( uint8_t, uint8_t );
void trigger_disable( uint8_t, uint8_t );
void EXTI9_5_Handler( void );
void EXTI15_10_Handler( void );
void EXTI2_Handler( void );
void set_interrupt_priority( uint8_t, uint8_t);

#endif /* CSI_interrupt_H_ */
