//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// August, 1 2018             Design Documents                  CSI_radio_info.h
//
//	           header for radio information for CS800D
//                      for Large Panel Project
//
//  Information here is for updating current screen information
//  when the radio has not sent an update, and the screen need to be refreshed.
//  Also used to store the information to flash during shutdown
//  and to read back info at startup.
//  Also will be used for user preferences information.
//
// Programmer
//  Dean S. Graham
//
// Copyright
//  Connect Systems Inc.
//
// History
//  08/01/2018 started
//
// Status
//  written
//
//==============================================================================
#ifndef RADIO_INFO_H_
#define RADIO_INFO_H_

// Radio information structure
typedef struct
{
  // Icons
  unsigned char i_scan;
  unsigned char i_privacy;   // all, group, private
  unsigned char i_inbox;
  unsigned char i_gps;
  unsigned char i_dis_tone;
  unsigned char i_talk_around;  
  unsigned char i_monitor;
  unsigned char i_emergency;
  unsigned char i_bt-state;  // ?? no icon for this
  unsigned char i_link;
  unsigned char i_lock;  
  // Zone
  int zone_num;
  char zone_alias[16];
  // Talkgroup
  char tlkgrp[16];
  // channel
  int chan_num;
  int chan_inzone;
  int chan_type;  // DMR, analog
  int chan_mode;  
  int rx_freq;
  int tx_freq;
  char chan_alias[16];
  // Settings
  int tx_pwr;
  int volume;
  
} Radio_Info;


#endif /* RADIO_INFO_H_ */