//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//==============================================================================
//
// June 29, 2018 		Design Documents      	            CSI_secure.h
//
//                 Header for security and code protection 
//
//      !!!======= CONFIDENTIAL, NOT FOR PUBLIC RELEASE ======= !!!!
//
// Programmer
//  Dean Graham
// 
// Copyright 
//  Connect Systems Inc.
//
// History
//  06/29/2018 started
//
// Status
//  writing
//
//******************************************************************************
#ifndef CSI_SECURE_H_
#define CSI_SECURE_H_

#include <stdint.h>

#define SECURE_EEPROM_ADD_HI  0xFF
#define SECURE_EEPROM_ADD_LO  0x80

//
// Device electronic signature, reference manual pg 1712
//
#define CPU_UNIQUE_ID_ADDRESS       0x1FFF7A10   // CPU id
#define CPU_WAFER_ADDRESS           0x1FFF7A14   // wafer XY
#define CPU_LOT_NUMBER_ADDRESS      0x1FFF7A18   // CPU lot number
#define CPU_FLASH_SIZE_ADDRESS      0x1FFF7A22   // flash size in Kbytes

uint32_t read_cpuID( void );
uint32_t read_cpu_waferXY( void );
uint32_t read_cpu_Lot( void );
void store_securepage( void );
void store_securepage2( void );
int check_securepage( void );
int check_securepage2( void );


#endif /* CSI_SECURE_H_ */