#include <stdint.h>
#include <string.h>
#include "CSI_RAM.h"
#include "CSI_FUNCTIONS.h"

#define  S1  1
#define  S2  2
#define  S3  3

#define  C1   50
#define  C3  100
#define  C4  150
#define  C5  200
#define  C6  250
#define  C7  300
#define  C8  400
#define  C9  450
#define C10  500
#define C11  550

#define  L2  100
#define  L3  400

void type_40_processing(unsigned char, unsigned char element);
//
// This array is used to define the properties of the other arrays below. The 
// definition is as follows:
//  parameter 1   size of character
//  parameter 2   length of array
//  parameter 3   number of items in array
//  parameter 4   start column address
//  parameter 5   start line address   
//
const uint16_t  define_type_40[][5] =
{
  S3,  4,  1,  C1, L3,   //Type 00
  S3,  4,  1,  C1, L3,   //Type 01
  S3,  4,  1,  C1, L3,   //Type 02
  S3,  4,  1,  C1, L3,   //Type 03
  S3,  4,  1,  C1, L3,   //Type 04
  S3,  4,  1,  C1, L3,   //Type 05
  S3,  4,  1,  C1, L3,   //Type 06
  S2, 17, 91,  C3, L2,   //Type 07
  S3,  4,  1,  C1, L3,   //Type 08
  S3,  4,  2, C10, L3,   //Type 09
  S3,  3,  2, C11, L3,   //Type 0A
  S3,  7,  2,  C7, L3,   //Type 0B
  S3,  7,  6,  C7, L3,   //Type 0C
  S3,  3,  7, C11, L3,   //Type 0D
  S3,  5,  3,  C9, L3,   //Type 0E
  S3,  4,  1,  C1, L3,   //Type 0F  
  
  S3,  6,  3,  C8, L3,   //Type 10
  S3,  4,  1,  C1, L3,   //Type 11
  S3,  4,  1,  C1, L3,   //Type 12
  S3,  3,  2, C11, L3,   //Type 13
  S3,  4,  3, C10, L3,   //Type 14
  S3,  7,  2,  C7, L3,   //Type 15
  S3,  5,  5,  C9, L3,   //Type 16
  S3,  4,  5, C10, L3,   //Type 17
  S3,  4,  1,  C1, L3,   //Type 18
  S3,  3,  3,  C6, L3,   //Type 19
  S3,  5, 20,  C9, L3,   //Type 1A
  S3,  7,  4,  C7, L3,   //Type 1B
  S3,  6,  2,  C8, L3,   //Type 1C
  S3,  7,  6,  C7, L3,   //Type 1D
  S3, 11,  4,  C5, L3,   //Type 1E
  S3,  4,  1,  C1, L3,   //Type 1F   
  
  S3,  5,  4,  C9, L3,   //Type 20
  S3,  4,  4, C10, L3,   //Type 21
  S3,  5,  3,  C9, L3,   //Type 22
  S3,  6, 32,  C8, L3,   //Type 23
  S3,  6, 16,  C8, L3,   //Type 24
  S3,  7,  7,  C7, L3,   //Type 25
  S3,  5,  4,  C9, L3,   //Type 26
  S3,  3,  7, C11, L3,   //Type 27
  S3,  6,  3,  C8, L3,   //Type 28
  S3,  4,  1,  C1, L3,   //Type 29
  S3,  4,  3, C11, L3,   //Type 2A
  S3,  4,  1,  C1, L3,   //Type 2B
  S3,  8,  3,  C6, L3,   //Type 2C
  S3,  6,  3,  C8, L3,   //Type 2D
  S3,  4,  1,  C1, L3,   //Type 2E
  S3,  4,  1,  C1, L3,   //Type 2F

  S3,  6, 30,  C8, L3,   //Type 30
  S3,  5,  3,  C8, L3,   //Type 31
  S3,  7,  2,  C7, L3,   //Type 32
  S3,  7,  2,  C7, L3,   //Type 33
  S3,  6,  2,  C8, L3,   //Type 34
  S3,  4,  1,  C1, L3,   //Type 35
  S3,  3,  3, C11, L3,   //Type 36
  S3,  4,  1,  C1, L3,   //Type 37
  S3,  4,  1,  C1, L3,   //Type 38
  S3,  3,  6, C11, L3,   //Type 39
  S3, 11,120,  C4, L3,   //Type 3A
  S3, 11,  6,  C4, L3,   //Type 3B
  S3,  4,  1,  C1, L3,   //Type 3C
  S3,  4,  1,  C1, L3,   //Type 3D
  S3, 11,  5,  C7, L3,   //Type 3E
  S3,  4,  1,  C1, L3,   //Type 3F

  S3,  4,  1,  C1, L3,   //Type 40
  S3,  4,  1,  C1, L3,   //Type 41
  S3,  4,  1,  C1, L3,   //Type 42
  S3,  4,  1,  C1, L3,   //Type 43
  S3,  4,  1,  C1, L3,   //Type 44
  S3,  4,  1,  C1, L3,   //Type 45
  S3,  4,  1,  C1, L3,   //Type 46
  S2,  4,  1,  C1, L2,   //Type 47
  S3,  4,  1,  C1, L3,   //Type 48
  S3,  4,  1,  C1, L3,   //Type 49
  S3,  4,  1,  C1, L3,   //Type 4A
  S3,  4,  1,  C1, L3,   //Type 4B
  S3,  4,  1,  C1, L3,   //Type 4C
  S3,  3,104, C11, L3,   //Type 4D
  S3,  4,  1,  C1, L3,   //Type 4E
  S3,  2,  1,  C9, L3,   //Type 4F  

  S3,  5, 50,  C9, L3,   //Type 50
  S3,  4,  1,  C1, L3,   //Type 51  
};

const uint8_t  Type_40_00[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_01[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_02[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_03[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_04[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_05[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_06[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_07[][17] =    // Main Selection of menus
{                                    // Length 17, number of items 91
  "EXT MENU         ",               // Column 3  line 2
  "144 MHz ARS      ",
  "430MHz ARS       ",
  "AM&FM DIAL       ",
  "AM MIC GAIN      ",
  "AM STEP          ",
  "APO TIME         ",
  "ARTS BEEP        ",
  "ARTS ID          ",
  "ARTS IDW         ",
  "BEACON TEXT 1    ",
  "BEACON TIME      ",
  "BEEP TONE        ",
  "BEEP VOL         ",
  "CAR LSB R        ",
  "CAR LSB T        ",

  "CAR USB R        ",
  "CAR USB T        ",
  "CAR RATE         ",
  "CAT/LIN/TUN      ",
  "CLAR DIAL SEL    ",
  "CW AUTO MODE     ",
  "CW BFO           ",
  "CW DELAY         ",
  "CW KEY REV       ",
  "CW PADDLE        ",
  "CW PITCH         ",
  "CW QSK           ",
  "CW SIDE TONE     ",
  "CW SPEED         ",
  "CW TRAINING      ",
  "CW WEIGHT        ",

  "DCS CODE         ",
  "DCS INV          ",
  "DIAL STEP        ",
  "DIG DISP         ",
  "DIG GAIN         ",
  "DIG MODE         ",
  "DIG SHIFT        ",
  "DIG VOX          ",
  "DISP COLOR       ",
  "DISP CONTRAST    ",
  "DISP INTENSITY   ",
  "DISP MODE        ",
  "DSP BPF WIDTH    ",
  "DSP HPF CUTOFF   ",
  "DSP LPF CUTOFF   ",
  "DSP MIC EQ       ",
    
  "DSP NR LEVEL     ",
  "EMERGENCY        ",
  "FM MIC GAIN      ",
  "FM STEP          ",
  "HOME ->VFO       ",
  "LOCK MODE        ",
  "MEM GROUP        ",
  "MEM TAG          ",
  "M/V/SEL DIAL MODE",
  "MIC SCAN         ",
  "MIC SEL          ",
  "MTR ARX SEL      ",
  "MTR ATX SEL      ",
  "MTR PEAK HOLD    ",
  "NB  LEVEL        ",
  "OP FILTER 1      ",

  "PG A             ",
  "PG B             ",
  "PG C             ",
  "PG ACC           ",
  "PG P1            ",
  "PG P2            ",
  "PKT 1200         ",
  "PKT 9600         ",
  "PKT RATE         ",
  "PROC LEVEL       ",
  "RF POWER SET     ",
  "RPT SHIFT        ",
  "SCAN MODE        ",
  "SCAN RESUME      ",
  "SPLIT TONE       ",
  "SQL/RF GAIN      ",
    
  "SSB MIC GAIN     ",
  "SSB STEP         ",
  "TONE FREQ        ",
  "TOT TIME         ",
  "TUNER/ATAS       ",
  "TX IF FILTER     ",
  "VOX DELAY        ",
  "VOX GAIN         ",
  "XVTR A FREQ      ",
  "XVTR B FREQ      ",
  "XVTR SEL         ",

};
const uint8_t  Type_40_08[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_09[][6] =     // CLAR DIAL SEL
{                                    // Length 4, number of items 2
  "MAIN",                            // Column 10, line 3
  " SEL", 
};
const uint8_t  Type_40_0A[][3] =     // EXT MENU
{                                    // Length 3, number of items 2 
  "OFF",                             // Column 11, line 3
  " ON",
};
const uint8_t  Type_40_0B[][7] =     // AM&FM DIAL
{                                    // Length 7, number of items 2 
  " ENABLE",                         // Column 7, line 3 
  "DISABLE",
};
const uint8_t  Type_40_0C[][7] =     // AM STEP
{                                    // Length 7, number of items 6
  " 2.5KHz",                         // Column 7, line 3
  "   5KHz",
  "   9KHz",
  "  10KHz",  
  "12.5KHz",  
  "  25KHz",  
};
const uint8_t  Type_40_0D[][3] =     // APO TIME
{                                    // Length 3, number of items 7
  "OFF",                             // Column 11, line 3
  " 1h",
  " 2h",
  " 3h",  
  " 4h",  
  " 5h", 
  " 6h", 
};
const uint8_t  Type_40_0E[][5] =     // ARTS BEEP
{                                    // Length 5, number of items 3
  "  OFF",                           // Column 9, line 3 
  "RANGE",
  "  ALL",
};
const uint8_t  Type_40_0F[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_10[][6] =     // BEEP TONE
{                                    // Length 6, number of items 3 
  " 440Hz",                          // Column 8, line 3 
  " 880Hz",
  "1760Hz",
};
const uint8_t  Type_40_11[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_12[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_13[][3] =     //
{                                    // Length 3,  number of items 2
  "OFF",                             // Column 11, line 3 
  " ON",
};

const uint8_t  Type_40_14[][4] =     // CW BFO
{                                    // Length  4, number of items 3 
  " USB",                            // Column 10, line 3 
  " LSB",
  "AUTO",
};
const uint8_t  Type_40_15[][7] =     // CW KEY REV
{                                    // Length  7, number of items 2
  " NORMAL",                         // Column  7, line 3 
  "REVERSE", 
};
const uint8_t  Type_40_16[][6] =     // CW PITCH
{                                    // Length 5, number of items 5
  "400Hz",                           // Column 9, line 3
  "500Hz",
  "600Hz",
  "700Hz",
  "800Hz",  
};
const uint8_t  Type_40_17[][4] =     // CW QSK
{                                    // Length 4,  number of items 5
  "10ms",                            // Column 10, line 3
  "15ms",
  "20ms",
  "25ms",
  "30ms",  
};
const uint8_t  Type_40_18[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_19[][2] =     // CW TRAINING
{                                    // Length 3,  number of items 3
  " N",                              // Column 6, line 3
  " A",
  "AN",
};
const uint8_t  Type_40_1A[][5] =     // ##########################################
{                                    // Length 5,  number of items 20 
  "1:2.5",                           // Column 9, line 3
  "1:2.6",
  "1:2.7",
  "1:2.8",
  "1:2.9",
  "1:3.0",
  "1:3.1",
  "1:3.2",
  "1:3.3",
  "1:3.4",
  "1:3.5",
  "1:3.6",
  "1:3.7",
  "1:3.8",
  "1:3.9",
  "1:4.0",
  "1:4.1",
  "1:4.2",
  "1:4.3",
  "1:4.4",  
};
const uint8_t  Type_40_1B[][7] =     // DCS INV
{                                    // Length 7, number of items 4
  "  Tn-Rn",                         // Column 7, line 3
  " Tn-RiV",
  " Tiv-Rn",
  "Tiv-Riv",
};
const uint8_t  Type_40_1C[][6] =     // DIAL STEP
{                                    // Length 6, number of items 2
  "  FINE",                          // Column 8, line 3
  "COARSE",
};
const uint8_t  Type_40_1D[][7] =     // DIG MODE
{                                    // Length 7, number of items 6
  " RTTY-L",                         // Column 7, line 3
  " RTTY-U",
  "PSK31-L",  
  "PSK31-U",   
  " USER-L",    
  " USER-U",    
};
const uint8_t  Type_40_1E[][11] =    // ##########################################
{                                    // Length 11, number of items 4
  "           ",  // undefined       // Column 5, line 3
  "Intensity 1",
  "Intensity 2", 
  "Intensity 3", 
};
const uint8_t  Type_40_1F[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_20[][11] =    // DISP MODE
{                                    // Length 5, number of items 4 
  "  OFF",                           // Column 9, line 3
  "AUTO1",
  "AUTO2", 
  "   ON", 
};
const uint8_t  Type_40_21[][4] =     // DSP MIC EQ
{                                    // Length 4,  number of items 4
  " OFF",                            // Column 10, line 3
  " LPF",
  " HPF", 
  "BOTH",
};
const uint8_t  Type_40_22[][5] =     // DSP BPF WIDTH
{                                    // Length 5, number of items 3
  " 60Hz",                           // Column 9, line 3
  "120Hz",
  "240Hz", 
};
const uint8_t  Type_40_23[][6] =     // DSP LPF CUTOFF
{                                    // Length 6, number of items 32
  "1000Hz",                          // Column 8, line 3
  "1160Hz",  
  "1320Hz",
  "1480Hz",
  "1650Hz",
  "1800Hz",
  "1970Hz",
  "2130Hz",
  "2290Hz",
  "2450Hz",
  "2610Hz",
  "2770Hz",
  "2940Hz",
  "3100Hz",
  "3260Hz",
  "3420Hz",
  "3580Hz",
  "3740Hz",
  "3900Hz",
  "4060Hz",
  "4230Hz",
  "4390Hz",
  "4550Hz",
  "4710Hz",
  "4870Hz",
  "5030Hz",
  "5190Hz",
  "5390Hz",
  "5520Hz",
  "5680Hz",
  "5840Hz", 
  "6000Hz",
};
const uint8_t  Type_40_24[][6] =     // DSP HPF CUTOFF
{                                    // Length 6, number of items 16
  " 100Hz",                          // Column 8, line 3
  " 160Hz",
  " 220Hz", 
  " 280Hz",
  " 340Hz",
  " 400Hz",   
  " 460Hz",
  " 520Hz", 
  " 580Hz",
  " 640Hz",
  " 700Hz",
  " 760Hz",
  " 820Hz", 
  " 880Hz",
  " 940Hz",
  "1000Hz",  
};
const uint8_t  Type_40_25[][7] =     // FM STEP
{                                    // Length 7, number of items 7
  "   5KHz",                         // Column 7, line 3
  "6.25KHz",
  "6.25KHz",
  "12.5KHz",
  "  15KHz",
  "  20KHz",
  "  50KHz",
};
const uint8_t  Type_40_26[][5] =     // LOCK MODE
{                                    // Length 5, number of items 4
  " DIAL",                           // Column 9, line 3
  "FREQ",
  "PANEL",
  "  ALL",
};  
const uint8_t  Type_40_27[][3] =     // MTR ATX SEL
{                                    // Length 3,  number of items 7
  "PWR",                             // Column 11, line 3
  "ALC",
  "MOD",
  "SWR",
  "VLT",
  "N/A",
  "OFF",
};   
const uint8_t  Type_40_28[][6] =     // CAT/LIN/TUNER
{                                    // Length 6, number of items 3
  "   CAT",                          // Column 8, line 3
  "LINEAR",
  " TUNER",
};
const uint8_t  Type_40_29[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_2A[][4] =     // SCAN MODE
{                                    // Length 4,  number of items 3
  "TIME",                            // Column 11, line 3
  "BUSY",
  "STOP",
};
const uint8_t  Type_40_2B[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_2C[][8] =     // CAT RATE
{                                    // Length 8, number of items 3
  " 4800bps",                        // Column 6, line 3
  " 9600bps",
  "38400bps",
};
const uint8_t  Type_40_2D[][8] =     // SSB STEP
{                                    // Length 6, number of items 3
  "  1KHz",                          // Column 8, line 3
  "2.5KHz",
  "  5KHz",
};
const uint8_t  Type_40_2E[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_2F[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_30[][6] =     // VOX DELAY
{                                    // Length 6, number of items 30
  "      ",   //UNKNOWN              // Column 8, line 3
  " 100ms",
  " 200ms",
  " 300ms",
  " 400ms",
  " 500ms",
  " 600ms",
  " 700ms",
  " 800ms",
  " 900ms",
  "1000ms",
  "1100ms",
  "1200ms",
  "1300ms",
  "1400ms",
  "1500ms",
  "1600ms",
  "1700ms",
  "1800ms",
  "1900ms",
  "2000ms",
  "2100ms",
  "2200ms",
  "2300ms",
  "2400ms",
  "2500ms",
  "2600ms",
  "2700ms",
  "2800ms",
  "2900ms",
  "3000MS",
};
const uint8_t  Type_40_31[][6] =     // XVTR SEL 
{                                    // Length 5, number of items 3
  "   OFF",                          // Column 8, line 3
  "XVTR A",
  "XVTR B",
};
const uint8_t  Type_40_32[][7] =     // PKT RATE
{                                    // Length 7, number of items 2
  "1200bps",                         // Column 7, line 3
  "9600bps",
};
const uint8_t  Type_40_33[][7] =     // SQL/RF GAIN
{                                    // Length 7, number of items 2
  "RF-GAIN",                         // Column 7, line 3
  "    SQL",
};
const uint8_t  Type_40_34[][6] =     // CW PADDLE
{                                    // Length 6, number of items 2
  "ELEKEY",                          // Column 8, line 3
  "MICKEY",
};
const uint8_t  Type_40_35[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_36[][3] =     // MIC SEL
{                                    // Length 3,  number of items 3 
  "NOR",                             // Column 11, line 3
  "RMT",
  "CAT",
};
const uint8_t  Type_40_37[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_38[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_39[][3] =     // MTR ARX SEL
{                                    // Length 3,  number of items 6
  "SIG",                             // Column 11, line 3
  "CTR",
  "VLT",
  "N/A",
  "FS ",
  "OFF",
};
const uint8_t  Type_40_3A[][11] =    // PG A OR PG B
{                                    // Length 11, number of items 120
  "        A/B",                     // Column 4,  line 3
  "        A=B",
  "        SPL",
  "         MW",
  "  SKIP/MCLR",
  "        TAG",
  "        STO",
  "        RCL",
  "       PROC",
  "        RPT",
  "        REV",
  "        VOX",
  "    TON/ENC",
  "       /DEC",    //CHECK.....
  "       TDCH",
  "       ARTS",

  "       SRCH",
  "        PMS",
  "        SCN",
  "        PRI",
  "         DW",
  "       SCOP",   
  "        WID",
  "       STEP",
  "        MTR",
  "        PWR",
  "       DISP",
  "       SPOT",
  "         BK",
  "        KYR",
  "       TUNE",  
  "       DOWN",
  
  "         UP",
  "         NB",
  "        AGC",
  "    AGC SEL",
  "        IPO",
  "        ATT",
  "        NAR",
  "       CFIL",
  "       FIL1",
  "       FIL2",  
  "       PLY1",
  "       PLY2",    
  "       PLY3",  
  "        DNR",
  "        DNF",
  "        DBF",  
  
  "01:EXT MENU",    //30  1-16
  "02:144MHz A",
  "03:430MHz A",
  "04:AM&FM DI",
  "05:AM MIC G",
  "06:AM STEP ",
  "07:APO TIME",
  "08:ARTS BEE",
  "09:ARTS ID ",
  "10:ARTS IDW",  
  "11:BEACON T",
  "12:BEACON T",    
  "13:BEEP TON",  
  "14:BEEP VOL",
  "15:CAR LSB ",
  "16:CAR LSB ", 
  
  "17:CAR USB ",    //40  17-32
  "18:CAR USB ",
  "19:CAT RATE",
  "20:CAT/LIN/",
  "21:CLAR DIA",
  "22:CW AUTO ",
  "23:CW BFO  ",
  "24:CW DELAY",
  "25:CW KEY R",
  "26:CW PADDL",  
  "27:CW PITCH",
  "28:CW QSK  ",    
  "29:CW SIDE ",  
  "30:CW SPEED",
  "31:CW TRAIN",
  "32:CW WEIGH",   
  
  "33:DCS CODE",    //50  33-48
  "34:DCS INV ",
  "35:DIAL STE",
  "36:DIG DISP",
  "37:DIG GAIN",
  "38:DIG MODE",
  "39:DIG SHIF",
  "40:DIG VOX ",
  "41:DISP COL",
  "42:DISP CON",  
  "43:DISP INT",
  "44:DISP MOD",    
  "45:DSP BPF ",  
  "46:DSP HPF ",
  "47:DSP LPF ",
  "48:DSP MIC",  
  
  "49:DSP NR L",    //60  49-64
  "50:EMERGENC",
  "51:FM MIC G",
  "52:FM STEP ",
  "53:HOME>VFO",
  "54:LOCK MOD",
  "55:MEM GROU",
  "56:MEM TAG ",
  "57:MEM/VFO ",
  "58:MIC SCAN",  
  "59:MIC SEL ",
  "60:MTR ARX ",    
  "61:MTR ATX ",  
  "62:MTR PEAK",
  "63:NB LEVEL",
  "64:OP FILTE",   

  "71:PKT 1200",    //70  71-86
  "72:PKT 9600",
  "73:PKT RATE",
  "74:PROC LEV",
  "75:RF POWER",
  "76:RPT SHIF",
  "77:SCAN MOD",
  "78:SCAN RES",
  "79:SPLIT TO",
  "80:SQL/RF G",  
  "81:SSB MIC ",
  "82:SSB STEP",    
  "83:TONE FRE",  
  "84:TOT TIME",
  "85:TUNER/AT",
  "86:TX IF FI",

  "87:VOX DELA",    //80  87-91, MISC
  "88:VOX GAIN",
  "89:XVTR A F",
  "90:XVTR B F",
  "91:XVTR SEL",
  "       MONI",
  "      Q.SPL",
  "      TCALL",
  "        ATC",
  "       USER", 
};
const uint8_t  Type_40_3B[][11] =    // M/V/SEL DIAL MODE
{                                    // Length 11, number of items 6  
  "CW SIDETONE",                     // Column 4,  line 3
  "   CW SPEED",
  "MHz/MEM GRP",
  "   MIC GAIN",
  "   NB LEVEL",
  "   RF POWER",
  "       STEP",
};
const uint8_t  Type_40_3C[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_3D[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_3E[][11] =    // ATAS(HF)
{                                    // Length 11, number of items 5  
  "        OFF",                     // Column 7,  line 3
  "   ATAS(HF)",
  "ATAS(HF&50)",
  "  ATAS(ALL)",
  "      TUNER",
};
const uint8_t  Type_40_3F[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_40[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_41[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  1                                  // Column 1  line 3
};
const uint8_t  Type_40_42[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_43[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
 "????"                             // Column 1  line 3
};
const uint8_t  Type_40_44[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_45[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_46[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_47[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_48[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_49[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_4A[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_4B[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_4C[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};
const uint8_t  Type_40_4D[][3] =     // DCS CODE
{                                    // Length 3,  number of items 104
  "023",                             // Column 11, line 3
  "025",
  "026",
  "031",
  "032",
  "036",
  "043",
  "047",
  "051",
  "053",
  
  "054",
  "065",
  "071",
  "072",
  "073",
  "074",
  "114",
  "115",
  "116",
  "122",
  
  "125",
  "131",
  "132",
  "134",
  "143",
  "145",
  "152",
  "155",
  "156",
  "162",
  
  "166",
  "172",
  "174",
  "205",
  "212",
  "223",
  "225",
  "226",
  "243",
  "244",
  
  "245",
  "246",
  "251",
  "252",
  "255",
  "261",
  "263",
  "265",
  "266",
  "271",
  
  "274",
  "306",
  "311",
  "315",
  "325",
  "331",
  "332",
  "343",
  "346",
  "351",
  
  "356",
  "364",
  "365",
  "371",
  "411",
  "412",
  "413",
  "423",
  "431",
  "432",
  
  "445",
  "446",
  "452",
  "454",
  "455",
  "462",
  "464",
  "465",
  "466",
  "503",
  
  "506",
  "516",
  "523",
  "526",
  "532",
  "546",
  "565",
  "606",
  "612",
  "624",

  "627",
  "631",
  "632",
  "654",
  "662",
  "664",
  "703",
  "712",
  "723",
  "731",
  
  "732",
  "734",
  "743",
  "754",
};
const uint8_t  Type_40_4E[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};

const uint8_t  Type_40_4F[][2] =     // DCS CODE
{                                    // Length 2, number of items 1
  "T:"                               // Column 9, line 3
};
const uint8_t  Type_40_50[][5] =     // TONE FREQ
{                                    // Length 5, number of items 50
  " 67.0",                           // Column 9, line 3
  " 69.3",
  " 71.9",
  " 74.4",
  " 77.0",
  " 79.7",
  " 82.5",
  " 85.4",
  
  " 88.5",
  " 91.5",
  " 94.8",
  " 97.4",  
  "100.0",
  "103.5",
  "107.2",
  "110.9",

  "114.8",
  "118.8",
  "123.0",  
  "127.3",
  "131.8",
  "136.5",
  "141.3",
  "146.2",

  "151.4",
  "156.7",
  "159.8",  
  "162.2",
  "165.5",
  "167.9",
  "171.3",
  "173.8",  
  
  "177.3",
  "179.9",
  "183.5",  
  "186.2",
  "189.9",
  "192.8",
  "196.6",
  "199.5", 
  
  "203.5",
  "206.5",
  "210.7",  
  "218.1",
  "225.7",
  "229.1",
  "233.6",
  "241.8",

  "250.3",
  "254.1",  
};
const uint8_t  Type_40_51[][4] =     // ##########################################
{                                    // Length 4, number of items 1 
  "????"                             // Column 1  line 3
};


//
void type_40_processing(unsigned char array_type, unsigned char element)
{
// 
// The protocol passes two parameters:
// 1. The array type. This is handled by the switch statement
// 2. The element in the array.
//
// There is also an array called define_type_40[][5] that has more information
// about what is happening. The first dimension of the array is the array type
// and its value matches what goes to the switch statement. This array has four
// parameters associated with each array type as follows: 
//  parameter 1   size of character
//  parameter 2   length of array. This is the number of characters to transfer
//                to the buffer that outputs data to the screen.
//  parameter 3   number of items in array.This is the number of different 
//                messages associated with each array and is used as a check to
//                make sure the number passed is valid. 
//  parameter 4   start horizontal address
//  parameter 5   start vertical address   
//
// The routine first takes the data in the array and passed it to the 
// cg_line_buffer[80]
//
// Then it must output the data to the screen
//

//
// Now determine if its a valid number and if not valid log into error log
//
  
//
// find data and transfer to buffer
//
  switch(array_type) {
    case 0x00:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_00[element],  4); //## 
      break;
    case 0x01:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_01[element],  4); //## 
      break;
    case 0x02:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_02[element],  4); //## 
      break;
    case 0x03:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_03[element],  4); //## 
      break;
    case 0x04:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_04[element],  4); //## 
      break;
    case 0x05:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_05[element],  4); //## 
      break;
    case 0x06:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_06[element],  4); //## 
      break;
    case 0x07:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_07[element], 17); //## 
      break;
    case 0x08:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_08[element],  4); //##
      break;
    case 0x09:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_09[element],  4); 
      break;
    case 0x0A:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_0A[element],  3); 
      break;      
    case 0x0B:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_0B[element],  7);
      break;      
    case 0x0C:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_0C[element],  7);
      break;
    case 0x0D:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_0D[element],  3);
      break;      
    case 0x0E:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_0E[element],  5);
      break;  
    case 0x0F:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_0E[element],  4); //##
      break;
      
      
    case 0x10:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_10[element],  6);
      break;
    case 0x11:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_11[element],  4); //##
      break;
    case 0x12:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_12[element],  4); //##
      break;
    case 0x13:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_13[element],  3); 
      break;      
    case 0x14:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_14[element],  4); 
      break;      
    case 0x15:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_15[element],  7); 
      break;
    case 0x16:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_16[element],  5); 
      break;      
    case 0x17:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_17[element],  4); 
      break;
    case 0x18:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_18[element],  4); 
      break;      
    case 0x19:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_19[element],  3); 
      break;
    case 0x1A:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_1A[element],  5); 
      break;      
    case 0x1B:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_1B[element],  7); 
      break;      
    case 0x1C:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_1C[element],  6); 
      break;
    case 0x1D:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_1D[element],  7); 
      break;      
    case 0x1E:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_1E[element], 11); 
      break; 
    case 0x1F:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_1F[element],  4); //## 
      break;
      

    case 0x20:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_20[element],  5);
      break;
    case 0x21:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_21[element],  4);
      break;
    case 0x22:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_22[element],  5);
      break;
    case 0x23:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_23[element],  6);
      break;      
    case 0x24:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_24[element],  6);
      break;      
    case 0x25:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_25[element],  7);
      break;
    case 0x26:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_26[element],  5);
      break;      
    case 0x27:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_27[element],  3);
      break;
    case 0x28:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_28[element],  6);
      break;
     case 0x29:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_29[element],  4); //##
      break;
    case 0x2A:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_2A[element],  4);
      break;   
     case 0x2B:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_2B[element],  4); //##
      break;
    case 0x2C:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_2C[element],  8);
      break;
    case 0x2D:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_2D[element],  6);
      break; 
    case 0x2E:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_2E[element],  4); //## 
      break; 
    case 0x2F:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_2F[element],  4); //## 
      break;      
      
   
    case 0x30:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_30[element],  6);
      break;
    case 0x31:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_31[element],  5);
      break;
    case 0x32:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_32[element],  7);
      break;
    case 0x33:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_33[element],  7);
      break;      
    case 0x34:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_34[element],  6);
      break;  
    case 0x35:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_35[element],  4); //##
      break;
    case 0x36:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_36[element],  3);
      break; 
    case 0x37:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_37[element],  4); //##
      break;
    case 0x38:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_38[element],  4); //##
      break;
    case 0x39:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_39[element],  3);
      break;
    case 0x3A:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_3A[element], 11);
      break;      
    case 0x3B:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_3B[element], 11);
      break;
    case 0x3C:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_3C[element],  4); //##
      break;
    case 0x3D:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_3D[element],  4); //##
      break;
    case 0x3E:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_3E[element], 11);
      break;
    case 0x3F:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_3F[element],  4); //##
      break;
      
      
    case 0x40:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_40[element],  4); //##
      break;
    case 0x41:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_41[element],  4); //##
      break;
    case 0x42:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_42[element],  4); //##
      break;
    case 0x43:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_43[element],  4); //##
      break;      
    case 0x44:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_44[element],  4); //##
      break;  
    case 0x45:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_45[element],  4); //##
      break;
    case 0x46:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_46[element],  4); //##
      break; 
    case 0x47:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_47[element],  4); //##
      break;
    case 0x48:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_48[element],  4); //##
      break;
    case 0x49:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_49[element],  4); //##
      break;
    case 0x4A:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_4A[element],  4); //##
      break;      
    case 0x4B:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_4B[element],  4); //##
      break;
    case 0x4C:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_4C[element],  4); //##
      break;      
    case 0x4D:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_4D[element],  3);
      break;  
    case 0x4E:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_4E[element],  4); //##
      break;       
    case 0x4F:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_4F[element],  2);
      break;

      
    case 0x50:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_50[element],  5);
      break;      
    case 0x51:
      strncpy( (char*)cg_line_buffer, (char const*) Type_40_51[element],  4); //##
      break;         
  }
//
// output cg_line_buffer to the display. The calling program passes
//  1. array_type
//  2. element
//  
// The array define_type_40[array_type][5] has the following information
//
//  parameter 0   size of character or character set
//  parameter 1   length of array
//  parameter 2   number of items in array
//  parameter 3   start column address
//  parameter 4   start line address   
//
// The program to write characters to the display needs the following parameters
//
//    cg_length is the number of characters to be displayed
//    cg_character_set indicates which character set to use.
//    cg_hori_location is the location of the top left corner of the character
//    cg_vert_location is the location of the top left corner of the character
//    cg_spacing indicates number of blanks bits between characters. 
//
  ssd1963_cg_write_line( (uint8_t) define_type_40[array_type][1],
                         (uint8_t) define_type_40[array_type][0],
                                   define_type_40[array_type][3], 
                                   define_type_40[array_type][4], 
                                   2);
}


/*  
A5 04 4A 99 0C EF  Color 1  Menu 41
A5 04 4A C9 0C 1F  Color 2
A5 04 4A F6 09 49  Color 3
A5 04 4A F3 06 43  Color 4
A5 04 4A F0 00 3A  Color 5 
A5 04 4A F3 00 3D  Color 6
A5 04 4A F6 00 40  Color 7
A5 04 4A F9 00 43  Color 8
A5 04 4A FC 00 46  Color 9
A5 04 4A FF 00 49  Color 10
A5 04 4A CF 00 19  Color 11
A5 04 4A 9F 00 E9  Color 12
A5 04 4A 6F 00 B9  Color 13
A5 04 4A 3F 00 89  Color 14
A5 04 4A 0F 00 59  Color 15
A5 04 4A 0F 03 59  Color 16
A5 04 4A 0F 06 5F  Color 17
A5 04 4A 0F 09 62  Color 18
A5 04 4A 0F 0C 65  Color 19
A5 04 4A 0F 0F 68  Color 20
A5 04 4A 0C 15 65  Color 21
A5 04 4A 09 0F 62  Color 22
A5 04 4A 06 0F 5F  Color 23
A5 04 4A 03 0F 5C  Color 24
A5 04 4A 00 0F 59  Color 25
A5 04 4A 30 0F 89  Color 26
A5 04 4A 60 0F B9  Color 27
A5 04 4A 90 0F E9  Color 28
A5 04 4A C0 0F 19  Color 29
A5 04 4A C3 0F 1C  Color 30
A5 04 4A C6 0F 1F  Color 31
A5 04 4A C9 0F 22  Color 32

A5 03 4D 03 50 Contrast 1  Menu 42
A5 03 4D 04 51 Contrast 2
A5 03 4D 05 52 Contrast 3
A5 03 4D 06 53 Contrast 4
A5 03 4D 07 54 Contrast 5
A5 03 4D 08 55 Contrast 6
A5 03 4D 09 56 Contrast 7
A5 03 4D 0A 57 Contrast 8
A5 03 4D 0B 58 Contrast 9  
A5 03 4D 0C 59 Contrast 10
A5 03 4D 0D 5A Contrast 11
A5 03 4D 0E 5B Contrast 12
A5 03 4D 0F 5C Contrast 13

A5 04 4A 30 0F 89

A5 03 4B 89 D4   
*/

