
//
// 
// The following is the op codes for the various fields
//
// opcode 100:bit field
// opcode 110:ascii field
// opcode 120:ascii field must fill
// opcode 130:binary field
// opcode 140:binary field, zero allowed
// opcode 150:CTCSS/DCS field
// opcode 160:LTR field
// opcode 170:paging sequence field
// opcode 180:telephone field
// opcode 190 CWID field
//
// ****************************************************************************
// This is the start of the global parameter programming
// ****************************************************************************
//
//
static unsigned char global_message[][16] = {
"                ",  // 0
"                ",  // 1
" TELCO PROGRAM  ",  // 2
" RADIO PROGRAM  ",  // 3
" PHONE PROGRAM  ",  // 4
" COMPU PROGRAM  ",  // 5
"  ACCESS CODE   ",  // 6
"DTMF TELCO LEVEL",  // 7
"DTMF RADIO LEVEL",  // 8
"BEEP RADIO LEVEL",  // 9
"BEEP TELCO LEVEL",  // 10
"CWID RADIO LEVEL",  // 11
"TELCO RADIO LEVL",  // 12
"RADIO TELCO LEVL",  // 13
"RADIO LIMIT LEVL",  // 14
"  PAGING LEVEL  ",  // 15
"CTCSS RADIO LEVL",  // 16
"DCS RADIO LEVEL ",  // 17
"LTR RADIO LEVEL ",  // 18
"  REPEAT LEVEL  ",  // 19
" EIA TONE LEVEL ",  // 20
"LOW GUARD LEVEL ",  // 21
"HIGH GUARD LEVEL",  // 22
"VOICE RADI0 LEVL",  // 23
"VOICE TELCO LEVL",  // 24
"   RADIO GAIN   ",  // 25
"   TELCO GAIN   ",  // 26
"   VOICE GAIN   ",  // 27
" COS OR SQUELCH ",  // 28
"  COS POLARITY  ",  // 29
"COS TRIGGER VOLT",  // 30
"COS ACQUIST TIME",  // 31
"COS RELEASE TIME",  // 32
" SENSE POLARITY ",  // 33
"SEN TRIGGER VOLT",  // 34
"SEN ACQUIST TIME",  // 35
"SEN RELEASE TIME",  // 36
"R VOX ACQUISTION",  // 37
" RX VOX RELEASE ",  // 38
"T VOX ACQUISTION",  // 39
" TX VOX RELEASE ",  // 40
" OPERATING MODE ",  // 41
" VOX OR CARRIER ",  // 42
"  VOX ACTIVITY  ",  // 43
"  TELCO DELAY   ",  // 44
" PRIVACY MODE   ",  // 45
" REPEAT ENABLE  ",  // 46
"    ID MODE     ",  // 47
" CWID OR VOICE  ",  // 48
" CWID CALL SIGN ",  // 49
" CWID FREQUENCY ",  // 50
"  ID INTERVAL   ",  // 51
" RPTR HANG TIME ",  // 52
" RPTR ACTIVITY  ",  // 53
" RPTR COURTESY  ",  // 54
" BEEP FREQUENCY ",  // 55
"  CONNECT CODE  ",  // 56
"DISCONNECT CODE ",  // 57
"  ACCESS DELAY  ",  // 58
" ACTIVITY TIMER ",  // 59
" TIMEOUT TIMER  ",  // 60
"  PTT AUTODIAL  ",  // 61
"PTT MINIMUM TIME",  // 62
"PTT MAXIMUM TIME",  // 63
"   STATION ID   ",  // 64
"    ID MODE     ",  // 65
" BUSY DISCONNECT",  // 66
"BUSY DISCO CYCLE",  // 67
"DIAL TONE DISCO ",  // 68
"DIAL DISCO TIME ",  // 69
" LINE DISCONNECT",  // 70
"   LINE DELAY   ",  // 71
"LINE INACTIVETY ",  // 72
"T COURTESY BEEP ",  // 73
"BUSY CHANNEL MON",  // 74
" RINGOUT NUMBER ",  // 75
"  RINGOUT MODE  ",  // 76
" RINGOUT ALERT  ",  // 77
"ANSWER RING NMBR",  // 78
"ANSWER PAGE NMBR",  // 79
"   RING SPACE   ",  // 80
"  RING ANSWER   ",  // 81
"RING TRANSITIONS",  // 82
"   REMOTE BASE  ",  // 83
"ANSW  VOICE NMBR",  // 84
" AUX RELAY MODE ",  // 85
"   PAGE MODE    ",  // 86
" TALK BACK TIME ",  // 87
"MOB TO MOB PAGE ",  // 88
" OVERDIAL DIGITS",  // 89
"CTCSS/DCS TIMER ",  // 90
"   BEEP ALERT   ",  // 91
"REPEAT SEQUENCE ",  // 92
" TURN ON DELAY  ",  // 93
" TURN OFF DELAY ",  // 94
" DTMF CHAR TIME ",  // 95
"  MONITOR MODE  ",  // 96
"R COURTESY BEEP ",  // 97
"RELAY ACCESSCODE",  // 98
"RING CUTOFF TIME",  // 99
"SPEED DIAL VOICE",  // 100
"  PHONE TIMEOUT ",  // 101
" MOBILE TIMEOUT ",  // 102
" MANUAL CONTROL ",  // 103
"LINE BUSY DETECT",  // 104
"  RPTR COMMAND  ",  // 105
" PHONE LINE DET ",  // 106
"                ",  // 107
"            1=EN",  // 108
"           RATIO",  // 109
"           0=COS",  // 110
"           1=POS",  // 111
"            1 MS",  // 112
"           10 MS",  // 113
"          100 MS",  // 114
"             SEC",  // 115
"             MIN",  // 116
"            MODE",  // 117
"           1=VOX",  // 118
"           RINGS",  // 119
"          CYCLES",  // 120
"          1=TONE",  // 121
"         MSG NUM",  // 122
"          CLICKS",  // 123
"            GAIN",  // 124
"        0=BEACON",  // 125
"            FREQ",  // 126
"        PAGE NUM",  // 127
"          DIGITS",  // 128
"           BEEPS",  // 129
"            TONE",  // 130
" PTT TO PAGE DLY",  // 131
" SPECIAL ACCESS ",  // 132
"TOLL RESTRICT 1 ",  // 133
"TOLL RESTRICT 2 ",  // 134
"TOLL RESTRICT 3 ",  // 135
"TOLL RESTRICT 4 ",  // 136
"TOLL RESTRICT 5 ",  // 137
"TOLL RESTRICT 6 ",  // 138
"TOLL RESTRICT 7 ",  // 139
"TOLL RESTRICT 8 ",  // 140
};
//
//          C         C  M  M     * CODE = OP CODE
//  L  E    U  L   L  U  I  A     * LENGTH = LENGTH OF FIELD
//  E  E    R  I   I  R  N  X     * EEPROM ADDRESS = ADDRESS + OFFSET
//C N  P       N   N              * CUR OLD = LOCATION TO DISPLAY OLD DATAQ
//O G  R    O  E   E  N  V  V     * CUR NEW = LOCATION TO DISPLAY NEW DATA
//D T  O    L         E  A  A     * LINE 1, 2 = DISPLAY NUMBER FOR LINE 1, LINE 2
//E H  M    D  1   2  W  L  L     * MIN, MAX VAL = MINIMUM AND MAXIMUM VALUE
//
static unsigned char global_fcb[][9] = { 
//
// Programming parameters
//          
130,1, 0,  17,2,  108,21,0, 1,   //01 telco programming
130,1, 1,  17,3,  108,21,0, 1,   //02 radio programming
130,1, 2,  17,4,  108,21,0, 1,   //03 phone programming
130,1, 3,  17,5,  108,21,0, 1,   //04 computer programming
120,6, 4,  17,6,  1,  25,0, 0,   //05 programming access code
//
// Level control
//
130,3, 10, 17,7,  109,21,0, 255, //06 dtmf telco level
130,3, 11, 17,8,  109,21,0, 255, //07 dtmf radio level
130,3, 12, 17,9,  109,21,0, 255, //08 beep radio level
130,3, 13, 17,10, 109,21,0, 255, //09 beep telco level
130,3, 14, 17,11, 109,21,0, 255, //10 cwid radio level*
130,3, 15, 17,12, 109,21,0, 255, //11 telco to radio level
130,3, 16, 17,13, 109,21,0, 255, //12 radio to telco level
130,3, 17, 17,14, 109,21,0, 255, //13 radio limit level
130,3, 18, 17,15, 109,21,0, 255, //14 paging radio level*
130,3, 19, 17,16, 109,21,0, 255, //15 ctcss radio level*
130,3, 20, 17,17, 109,21,0, 255, //16 dcs radio level*
130,3, 21, 17,18, 109,21,0, 255, //17 ltr radio level*
130,3, 22, 17,19, 109,21,0, 255, //18 repeat radio level*
130,3, 23, 17,20, 109,21,0, 255, //19 eia tone level
130,3, 24, 17,21, 109,21,0, 255, //20 eia low guard tone level
130,3, 25, 17,22, 109,21,0, 255, //21 eia high guard tone level
130,3, 26, 17,23, 109,21,0, 255, //22 voice radio level
130,3, 27, 17,24, 109,21,0, 255, //23 voice telco level
130,2, 28, 17,25, 124,21,1, 16,  //24 radio gain
130,2, 29, 17,26, 124,21,1, 16,  //25 telco gain
130,1, 30, 17,27, 124,21,1, 16,  //26 voice gain*
//
// COS/Squelch Parameters
//
130,1, 31, 17,28, 110,21,0, 1,   //27 cos or internal squelch
130,1, 32, 17,29, 111,21,0, 1,   //28 cos polarity select
130,3, 33, 17,30, 109,21,0, 255, //29 cos trigger voltage
130,2, 34, 17,31, 112,21,0, 99,  //30 cos acquistion time
130,2, 35, 17,32, 113,21,0, 99,  //31 cos release time
//
// Sense Parameters
//
130,1, 36, 17,33, 111,21,0, 1,   //32 sense polarity select
130,3, 37, 17,34, 109,21,0, 255, //33 sense trigger voltage
130,2, 38, 17,35, 112,21,0, 99,  //34 sense acquistion time
130,2, 39, 17,36, 113,21,0, 99,  //35 sense release time
//
// Rx Vox Parameters
//
130,2, 40, 17,37, 112,21,0, 99,  //36 rx vox acquisition time
130,2, 41, 17,38, 114,21,0, 99,  //37 rx vox release time
//
// Tx Vox Parameters
//
130,2, 42, 17,39, 112,21,0, 99,  //38 tx vox acquisition time
130,2, 43, 17,40, 114,21,0, 99,  //39 tx vox release time
//
// Operating Mode Selection Parameters
//
130,1, 44, 17,41, 117,21,0, 2,   //40 operating mode
//
// Vox Mode Parameters
//
130,1, 45, 17,42, 118,21,0, 1,   //41 rx vox or carrier control
130,2, 46, 17,43, 116,21,0, 99,  //42 vox activity
130,2, 47, 17,44, 113,21,0, 40,  //43 voice delay from telephone
//
// Duplex Mode Parameters
//
130,1, 48, 17,45, 108,21,0, 1,   //44 semi-duplex privacy mode*
130,1, 49, 17,46, 108,21,0, 1,   //45 repeater controller enable*
130,1, 50, 17,47, 125,21,0, 1,   //46 station identification mode*
130,1, 51, 17,48, 117,21,0, 8,   //47 cwid or voice*
190,10,52, 17,49, 1,  17,0, 0,   //48 cwid call sign*
130,2, 62, 17,50, 126,21,1, 20,  //49 cwid frequency*
130,2, 63, 17,51, 116,21,0, 99,  //50 cwid or voice interval*
130,2, 64, 17,52, 114,21,0, 99,  //51 repeater hang time*
130,2, 65, 17,53, 115,21,0, 99,  //52 repeater activity timer*
130,1, 66, 17,54, 108,21,0, 1,   //53 repeater courtesy beep*
130,2, 67, 17,55, 126,21,1, 20,  //54 courtesy beep frequency*
//
// General Phone Patch Operating Parameters
//
110,6, 68, 17,56,  1, 25,0, 0,   //55 connect code
110,6, 74, 17,57,  1, 25,0, 0,   //56 disconnect code
130,2, 80, 17,58, 114,21,10,99,  //57 access delay
140,2, 81, 17,59, 115,21,0, 99,  //58 activity timer
130,2, 82, 17,60, 116,21,0, 99,  //59 timeout timer
130,1, 83, 17,61, 123,21,0, 9 ,  //60 ptt auto-dial
130,2, 84, 17,62, 114,21,5, 99,  //61 ptt autodial minimum time
130,2, 85, 17,63, 114,21,5, 99,  //62 ptt autodial maximum time
130,1, 86, 17,64, 122,21,0, 8,   //63 station identification
130,1, 87, 17,65, 117,21,0, 3,   //64 station identification mode
130,1, 88, 17,66, 108,21,0, 1,   //65 busy signal disconnect
130,1, 89, 17,67, 120,21,2, 9,   //66 busy disconnect cycle
130,1, 90, 17,68, 108,21,0, 1,   //67 dial tone disconnect
130,2, 91, 17,69, 114,21,20,99,  //68 dial disconnect time
130,1, 92, 17,70, 117,21,0, 2,   //69 line current disconnect
130,2, 93, 17,71, 113,21,0, 99,  //70 line delay
130,2, 94, 17,72, 112,21,0, 99,  //71 line disconnect time
130,1, 95, 17,73, 108,21,0, 1,   //72 teleco courtesy beep*
//
// Incomming Calls
//
130,1, 96, 17,74, 108,21,0, 1 ,  //73 busy channel monitor
130,1, 97, 17,75, 119,21,0, 9 ,  //74 ringout number
130,1, 98, 17,76, 117,21,0, 2,   //75 ringout mode
130,1, 99, 17,77, 122,21,0, 99,  //76 ringout alert
130,1, 100,17,78, 119,21,0, 9,   //77 auto answer ring number
130,2, 101,17,79, 127,21,0, 99,  //78 auto page page number*
130,2, 102,17,80, 114,21,0, 99,  //79 ring space
130,1, 103,17,81, 117,21,0, 1,   //80 ring answer
130,3, 104,17,82, 120,21,1, 255, //81 ring detect
130,1, 105,17,83, 117,21,0, 1,   //82 telephone remote base
130,1, 106,17,84, 122,21,0, 7,   //83 voice message on connect
130,1, 107,17,85, 117,21,0, 4,   //84 aux relay mode
//
// Paging Parameters
//
130,1, 108,17,86, 117,21,0, 1,   //85 page mode*
130,2, 109,17,87, 115,21,3, 99,  //86 talk back time*
130,1, 110,17,88, 108,21,0, 1,   //87 mobile to mobile page*
130,1, 111,17,89, 128,21,1, 4,   //88 overdial digits*
130,2, 112,17,90, 115,21,0, 99,  //89 ctcss/dcs timer*
130,1, 113,17,91, 129,21,0, 9,   //90 beep alert*
130,1, 114,17,92, 120,21,1, 9,   //91 repeat sequence*
//
// Miscellaneous Parameters
//
130, 3, 115,17,93, 113,21,0, 255,//92 turn on delay
130,2, 116,17,94, 113,21,0, 99,  //93 turn off delay
130,2, 117,17,95, 114,21,5, 99,  //94 dtmf character time
130,1, 118,17,96, 117,21,0, 1 ,  //95 monitor mode
130,1, 119,17,97, 108,21,0, 1,   //96 radio courtesy beep 
120,3, 120,17,98, 1,  25,0, 0,   //97 aux relay access code
130,2, 123,17,99, 115,21,0, 99,  //98 ring cutoff time
130,1, 124,17,100,122,21,0, 7,   //99 speed dial voice
130,2, 125,17,101,115,21,0, 99,  //100 inactivity timer for phone
130,2, 126,17,102,115,21,0, 99,  //101 inactivity timer for mobile
130,1, 127,17,103,108,21,0,  1,  //102 manual control
130,1, 128,17,104,108,21,0,  1,  //103 local phone line busy detector
110,3, 129,17,105,  1,25,0,  0,  //104 rptr command code
130,1, 132,17,106,108,21,0,  1,  //105 phone line detector enable or disable
130,2, 133,17,131,114,21,0, 99,  //106 ptt to paging delay
//
//          C         C  M  M     * CODE = OP CODE
//  L  E    U  L   L  U  I  A     * LENGTH = LENGTH OF FIELD
//  E  E    R  I   I  R  N  X     * EEPROM ADDRESS = ADDRESS + OFFSET
//C N  P       N   N              * CUR OLD = LOCATION TO DISPLAY OLD DATAQ
//O G  R    O  E   E  N  V  V     * CUR NEW = LOCATION TO DISPLAY NEW DATA
//D T  O    L         E  A  A     * LINE 1, 2 = DISPLAY NUMBER FOR LINE 1, LINE 2
//E H  M    D  1   2  W  L  L     * MIN, MAX VAL = MINIMUM AND MAXIMUM VALUE
110,6, 134,17,132, 1, 25,0, 0,   //107 special connect code
110,5, 140,17,133, 1, 25,0, 0,   //108 1oll restrict 1
110,5, 145,17,134, 1, 25,0, 0,   //109 1oll restrict 2
110,5, 150,17,135, 1, 25,0, 0,   //110 1oll restrict 3
110,5, 155,17,136, 1, 25,0, 0,   //111 1oll restrict 4
110,5, 160,17,137, 1, 25,0, 0,   //112 1oll restrict 5
110,5, 165,17,138, 1, 25,0, 0,   //113 1oll restrict 6
110,5, 170,17,139, 1, 25,0, 0,   //114 1oll restrict 7
110,5, 175,17,140, 1, 25,0, 0,   //115 1oll restrict 8
};


static unsigned char global_defaults[] = {
//
// Programming parameters
// 
1,                              //01 telco programming
1,                              //02 radio programming
1,                              //03 phone programming
1,                              //04 computer programming
0x31,0x32,0x33,0x34,0x35,0x36,  //05 programming access code
//
// Level control
//
255,                            //06 dtmf telco level
50,                             //07 dtmf radio level
50,                             //08 beep radio level
50,                             //09 beep telco level
50,                             //10 cwid radio level
255,                            //11 telco to radio level
255,                            //12 radio to telco level
255,                            //13 radio limit level
255,                            //14 paging radio level
255,                            //15 ctcss radio level
255,                            //16 dcs radio level
255,                            //17 ltr radio level
255,                            //18 repeat radio level
50,                             //19 eia tone level
50,                             //20 eia low guard tone level
50,                             //21 eia high guard tone level
255,                            //22 voice radio level
255,                            //23 voice telco level
1,                              //24 radio gain
1,                              //25 telco gain
1,                              //26 voice gain
//
// COS/Squelch Parameters
//
0,                              //27 cos or internal squelch
1,                              //28 cos polarity select
128,                            //29 cos trigger voltage
0,                              //30 cos acquistion time
10,                             //31 cos release time
//
// Sense Parameters
//
1,                              //32 sense polarity select
128,                            //33 sense trigger voltage
0,                              //34 sense acquistion time
10,                             //35 sense release time
//
// Rx Vox Parameters
//
0,                              //36 rx vox acquisition time
10,                             //37 rx vox release time
//
// Tx Vox Parameters
//
0,                              //38 tx vox acquisition time
10,                             //39 tx vox release time
//
// Operating Mode Selection Parameters
//
0,                              //40 operating mode
//
// Vox Mode Parameters
//
1,                              //41 rx vox or carrier control
0,                              //42 vox activity
40,                             //43 voice delay from telephone
//
// Duplex Mode Parameters
//
1,                              //44 semi-duplex privacy
0,                              //45 repeater enable
0,                              //46 station identification mode
0,                              //47 CWID or Voice
0x20,0x20,0x20,0x20,0x20,       //48 CWID call sign
0x20,0x20,0x20,0x20,0x20,
5,                              //49 CWID frequency
20,                             //50 CW or Voice ID interval
30,                             //51 Repeater Hang time
30,                             //52 Repeater Activity timer
1,                              //53 Repeater Courtesy Beep
5,                              //54 Courtesy Beep Frequency
//
// General Phone Patch Operating Parameters
//
0x20,0x20,0x20,0x20,0x20,0x20,  //55 connect code
0x20,0x20,0x20,0x20,0x20,0x20,  //56 disconnect code
30,                             //57 turn around delay
30,                             //58 activity timer
3,                              //59 timeout timer
0,                              //60 PTT autodial
5,                              //61 ptt autodial minimum time
15,                             //62 ptt autodial maximum time
0,                              //63 station identification
1,                              //64 station identification mode
1,                              //65 busy signal disconnect
7,                              //66 number of busy cycles
1,                              //67 dial tone disconnect
70,                             //68 dial disconnect time
1,                              //69 line current disconnect
99,                             //70 line delay
5,                              //71 line disconnect release time 
0,                              //72 Telephone Courtesy Beep
//
// Incomming calls
//
0,                              //73 busy channel monitor
1,                              //74 ringout number
1,                              //75 ringout mode
0,                              //76 ringout alert
2,                              //77 auto answer ring number
0,                              //78 auto answer page number
99,                             //79 ring space
0,                              //80 ring answer
10,                             //81 ring pulse counter
0,                              //82 telephone remote base
0,                              //83 voice message on connect
0,                              //84 aux relay mode
//
// Paging Parameters
//
0,                              //85 page mode
24,                             //86 talk back time
1,                              //87 mobile to mobile paging
3,                              //88 overdial digits
0,                              //89 ctcss/dcs timer
6,                              //90 ctcss/dcs beep alert
1,                              //91 repeat sequence
//
// Miscellaneous Parameters
//
10,                             //92 turn on delay
10,                             //93 turn off delay
50,                             //94 dtmf character time
0,                              //95 monitor mode
0,                              //96 radio courtesy beep 
0x37,0x38,0x39,                 //97 aux relay access code
45,                             //98 ring cutoff time
0,                              //99 speed dial voice
0,                              //100 inactivity timer for phone
0,                              //101 inactivity timer for mobile
0,                              //102 manual control
0,                              //103 local phone line busy detector
0x31,0x32,0x33,                 //104 rptr command code
1,                              //105 phone line detector enable or disable
0,                              //106 ptt to paging delay
//
// Toll Restrictions
//
0x20,0x20,0x20,0x20,0x20,0x20,  //107 special connect code
0x20,0x20,0x20,0x20,0x20,       //108 toll restrict 1
0x20,0x20,0x20,0x20,0x20,       //109 toll restrict 2
0x20,0x20,0x20,0x20,0x20,       //110 toll restrict 3
0x20,0x20,0x20,0x20,0x20,       //111 toll restrict 4
0x20,0x20,0x20,0x20,0x20,       //112 toll restrict 5
0x20,0x20,0x20,0x20,0x20,       //113 toll restrict 6
0x20,0x20,0x20,0x20,0x20,       //114 toll restrict 7
0x20,0x20,0x20,0x20,0x20,       //115 toll restrict 8
};


