//
// Define Base Address of Ports
//
#define GPIOA                0x40020000  // PORT A
#define GPIOB                0x40020400  // PORT B
#define GPIOC                0x40020800  // PORT C
#define GPIOD                0x40020C00  // PORT D
#define GPIOE                0x40021000  // PORT E
#define GPIOF                0x40021400  // PORT F
#define GPIOG                0x40021800  // PORT G
//
// GPIOA addresses
//
#define GPIOA_MODER_ADDRESS       0x40020000   // Port Mode Register
#define GPIOA_OTYPER_ADDRESS      0x40020004   // Output Type Register
#define GPIOA_OSPEEDR_ADDRESS     0x40020008   // Output Speed Register
#define GPIOA_PUPDR_ADDRESS       0x4002000C   // Push Up-Pull Down Register
#define GPIOA_IDR_ADDRESS         0x40020010   // Input Data Register
#define GPIOA_ODR_ADDRESS         0x40020014   // Output Data Register
#define GPIOA_BSRR_ADDRESS        0x40020018   // bit set/reset Register
#define GPIOA_LCKR_ADDRESS        0x4002001C   // Configuration Lock Register
#define GPIOA_AFRL_ADDRESS        0x40020020   // Alternate Function Low Register
#define GPIOA_AFRH_ADDRESS        0x40020024   // Alternate Function High Register
//
// GPIOB addresses
//
#define GPIOB_MODER_ADDRESS       0x40020400   // Port Mode Register
#define GPIOB_OTYPER_ADDRESS      0x40020404   // Output Type Register
#define GPIOB_OSPEEDR_ADDRESS     0x40020408   // Output Speed Register
#define GPIOB_PUPDR_ADDRESS       0x4002040C   // Push Up-Pull Down Register
#define GPIOB_IDR_ADDRESS         0x40020410   // Input Data Register
#define GPIOB_ODR_ADDRESS         0x40020414   // Output Data Register
#define GPIOB_BSRR_ADDRESS        0x40020418   // bit set/reset Register
#define GPIOB_LCKR_ADDRESS        0x4002041C   // Configuration Lock Register
#define GPIOB_AFRL_ADDRESS        0x40020420   // Alternate Function Low Register
#define GPIOB_AFRH_ADDRESS        0x40020424   // Alternate Function High Register
//
// GPIOC addresses
//
#define GPIOC_MODER_ADDRESS       0x40020800   // Port Mode Register
#define GPIOC_OTYPER_ADDRESS      0x40020804   // Output Type Register
#define GPIOC_OSPEEDR_ADDRESS     0x40020808   // Output Speed Register
#define GPIOC_PUPDR_ADDRESS       0x4002080C   // Push Up-Pull Down Register
#define GPIOC_IDR_ADDRESS         0x40020810   // Input Data Register
#define GPIOC_ODR_ADDRESS         0x40020814   // Output Data Register
#define GPIOC_BSRR_ADDRESS        0x40020818   // bit set/reset Register
#define GPIOC_LCKR_ADDRESS        0x4002081C   // Configuration Lock Register
#define GPIOC_AFRL_ADDRESS        0x40020820   // Alternate Function Low Register
#define GPIOC_AFRH_ADDRESS        0x40020824   // Alternate Function High Register
//
// GPIOD addresses
//
#define GPIOD_MODER_ADDRESS       0x40020C00   // Port Mode Register
#define GPIOD_OTYPER_ADDRESS      0x40020C04   // Output Type Register
#define GPIOD_OSPEEDR_ADDRESS     0x40020C08   // Output Speed Register
#define GPIOD_PUPDR_ADDRESS       0x40020C0C   // Push Up-Pull Down Register
#define GPIOD_IDR_ADDRESS         0x40020C10   // Input Data Register
#define GPIOD_ODR_ADDRESS         0x40020C14   // Output Data Register
#define GPIOD_BSRR_ADDRESS        0x40020C18   // bit set/reset Register
#define GPIOD_LCKR_ADDRESS        0x40020C1C   // Configuration Lock Register
#define GPIOD_AFRL_ADDRESS        0x40020C20   // Alternate Function Low Register
#define GPIOD_AFRH_ADDRESS        0x40020C24   // Alternate Function High Register
//
// GPIOE addresses
//
#define GPIOE_MODER_ADDRESS       0x40021000   // Port Mode Register
#define GPIOE_OTYPER_ADDRESS      0x40021004   // Output Type Register
#define GPIOE_OSPEEDR_ADDRESS     0x40021008   // Output Speed Register
#define GPIOE_PUPDR_ADDRESS       0x4002100C   // Push Up-Pull Down Register
#define GPIOE_IDR_ADDRESS         0x40021010   // Input Data Register
#define GPIOE_ODR_ADDRESS         0x40021014   // Output Data Register
#define GPIOE_BSRR_ADDRESS        0x40021018   // bit set/reset Register
#define GPIOE_LCKR_ADDRESS        0x4002101C   // Configuration Lock Register
#define GPIOE_AFRL_ADDRESS        0x40021020   // Alternate Function Low Register
#define GPIOE_AFRH_ADDRESS        0x40021024   // Alternate Function High Register
//
// GPIOF addresses
//
#define GPIOF_MODER_ADDRESS       0x40021400   // Port Mode Register
#define GPIOF_OTYPER_ADDRESS      0x40021404   // Output Type Register
#define GPIOF_OSPEEDR_ADDRESS     0x40021408   // Output Speed Register
#define GPIOF_PUPDR_ADDRESS       0x4002140C   // Push Up-Pull Down Register
#define GPIOF_IDR_ADDRESS         0x40021410   // Input Data Register
#define GPIOF_ODR_ADDRESS         0x40021414   // Output Data Register
#define GPIOF_BSRR_ADDRESS        0x40021418   // bit set/reset Register
#define GPIOF_LCKR_ADDRESS        0x4002141C   // Configuration Lock Register
#define GPIOF_AFRL_ADDRESS        0x40021420   // Alternate Function Low Register
#define GPIOF_AFRH_ADDRESS        0x40021424   // Alternate Function High Register
//
// GPIOG addresses
//
#define GPIOG_MODER_ADDRESS       0x40021800   // Port Mode Register
#define GPIOG_OTYPER_ADDRESS      0x40021804   // Output Type Register
#define GPIOG_OSPEEDR_ADDRESS     0x40021808   // Output Speed Register
#define GPIOG_PUPDR_ADDRESS       0x4002180C   // Push Up-Pull Down Register
#define GPIOG_IDR_ADDRESS         0x40021810   // Input Data Register
#define GPIOG_ODR_ADDRESS         0x40021814   // Output Data Register
#define GPIOG_BSRR_ADDRESS        0x40021818   // bit set/reset Register
#define GPIOG_LCKR_ADDRESS        0x4002181C   // Configuration Lock Register
#define GPIOG_AFRL_ADDRESS        0x40021820   // Alternate Function Low Register
#define GPIOG_AFRH_ADDRESS        0x40021824   // Alternate Function High Register

//
// Define bit pattern used for BSRR register used to turn on port bit
//
#define BIT00_ON            0x00000001
#define BIT01_ON            0x00000002
#define BIT02_ON            0x00000004
#define BIT03_ON            0x00000008
#define BIT04_ON            0x00000010
#define BIT05_ON            0x00000020
#define BIT06_ON            0x00000040
#define BIT07_ON            0x00000080
#define BIT08_ON            0x00000100
#define BIT09_ON            0x00000200
#define BIT10_ON            0x00000400
#define BIT11_ON            0x00000800
#define BIT12_ON            0x00001000
#define BIT13_ON            0x00002000
#define BIT14_ON            0x00004000
#define BIT15_ON            0x00008000
//
// Define bit pattern used for BSRR register used to turn off port bit
//
#define BIT00_OFF           0x00010000
#define BIT01_OFF           0x00020000
#define BIT02_OFF           0x00040000
#define BIT03_OFF           0x00080000
#define BIT04_OFF           0x00100000
#define BIT05_OFF           0x00200000
#define BIT06_OFF           0x00400000
#define BIT07_OFF           0x00800000
#define BIT08_OFF           0x01000000
#define BIT09_OFF           0x02000000
#define BIT10_OFF           0x04000000
#define BIT11_OFF           0x08000000
#define BIT12_OFF           0x10000000
#define BIT13_OFF           0x20000000
#define BIT14_OFF           0x40000000
#define BIT15_OFF           0x80000000
//
// Define bit mask
//
#define BIT00_MASK          0x00000001
#define BIT01_MASK          0x00000002
#define BIT02_MASK          0x00000004
#define BIT03_MASK          0x00000008
#define BIT04_MASK          0x00000010
#define BIT05_MASK          0x00000020
#define BIT06_MASK          0x00000040
#define BIT07_MASK          0x00000080
#define BIT08_MASK          0x00000100
#define BIT09_MASK          0x00000200
#define BIT10_MASK          0x00000400
#define BIT11_MASK          0x00000800
#define BIT12_MASK          0x00001000
#define BIT13_MASK          0x00002000
#define BIT14_MASK          0x00004000
#define BIT15_MASK          0x00008000

